SystemOrganization addCategory: #CMakeVMMaker!
SystemOrganization addCategory: #'CMakeVMMaker-Unix'!
SystemOrganization addCategory: #'CMakeVMMaker-Windows'!
SystemOrganization addCategory: #'CMakeVMMaker-MacOS'!
SystemOrganization addCategory: #'CMakeVMMaker-IOS'!
SystemOrganization addCategory: #'CMakeVMMaker-FreeBSD'!

!InterpreterPlugin class methodsFor: '*CMakeVMMaker' stamp: 'Igor.Stasenko 12/21/2010 14:26'!
addExtraCMakeRules: maker
	"Add extra rules/commands to cmake configuration for building this plugin.
	By default , do nothing"! !

!InterpreterPlugin class methodsFor: '*CMakeVMMaker' stamp: 'Igor.Stasenko 12/22/2010 01:10'!
generateFor: aCMakeVMGenerator internal: aBoolean 

	^ aCMakeVMGenerator 
		generatePlugin: self 
		internal: aBoolean
		extraRules: nil! !

!InterpreterPlugin class methodsFor: '*CMakeVMMaker' stamp: 'Igor.Stasenko 12/20/2010 04:18'!
supportedPlatforms: enum
" use:
	^ enum unix
or:
	^ enum unix, enum osX
	
or 

	^ enum unix i386, enum osX
"
	^ enum all! !

Object subclass: #CMakeGenScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakeGenScripts commentStamp: 'Igor.Stasenko 12/30/2010 09:53' prior: 0!
This class is a collection of scripts for generating both
C source files (using VMMaker) and Cmake files.!

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/28/2011 10:54'!
fileout: aString to: aFileName

	" put that file to ../codegen-scripts directory "
	
 	(FileStream forceNewFileNamed: aFileName) 
		nextPutAll: aString;
		close.
	! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/28/2011 10:53'!
fileoutLoaderScript
"self fileoutLoaderScript"


	" put that file to ../codegen-scripts directory "
	
	self fileout: self loaderScript to: self loaderScriptName.! !

!CMakeGenScripts class methodsFor: 'sources generation' stamp: 'EstebanLorenzano 2/6/2011 09:15'!
generateCocoaVM
	| platformDirectoryName |

"B3DAcceleratorPlugin" "Not using it right now"

	platformDirectoryName := (FileDirectory default 
		containingDirectory 
			directoryNamed: 'platforms') 
				fullName.
	VMMaker default 
		platformRootDirectoryName:  platformDirectoryName; 
		sourceDirectoryName: platformDirectoryName, '/iOS/vm/src';
		internal: #(
			ADPCMCodecPlugin 
			B3DEnginePlugin 
			BalloonEnginePlugin
			BitBltSimulation 
			BMPReadWriterPlugin 
			ClipboardExtendedPlugin 
			DeflatePlugin 
			DSAPlugin 
			FFIPlugin 
			FFTPlugin 
			FilePlugin 
			FloatArrayPlugin 
			GeniePlugin 
			HostWindowPlugin 
			JPEGReaderPlugin 
			JPEGReadWriter2Plugin 
			KlattSynthesizerPlugin 
			LargeIntegersPlugin 
			Matrix2x3Plugin 
			MacMenubarPlugin 
			MiscPrimitivePlugin
			NewsqueakIA32ABIPlugin 
			ObjectiveCPlugin
			RePlugin 
			SecurityPlugin 
			SocketPlugin 
			SoundCodecPlugin 
			SoundGenerationPlugin 
			SoundPlugin 
			StarSqueakPlugin 
			SurfacePlugin 
			UUIDPlugin 
			DropPlugin)	
		external: #(
			UnixOSProcessPlugin);
		generateMainVM;
		generateExternalPlugins.

	"Gnuifier"
	(Gnuifier on:((FileDirectory on: platformDirectoryName, '/iOS/vm/src/vm') pathName)) gnuify.	
! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'IgorStasenko 4/12/2011 13:24'!
loaderScript

"
Gofer new
	squeaksource: 'MetacelloRepository';
	package: 'ConfigurationOfCog';
	load.
	
((Smalltalk at: #ConfigurationOfCog) project
	version: '1.7') load.

(Smalltalk saveAs: 'generator.image') ifFalse: [
				 Smalltalk snapshot: false andQuit: true]
"

" i put it into comment to avoid double quoting "

^  thisContext  method methodNode comment first

! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/28/2011 10:53'!
loaderScriptName
	^ 'LoadVMMaker.st'! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/27/2011 12:19'!
mcPackage: name
	
	|pkg|
	pkg := MCWorkingCopy allManagers detect: [:ea | ea packageName = name ].
	
	^ pkg ancestry ancestorString , '.mcz'
	! !

!CMakeGenScripts methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/30/2010 09:52'!
seeClassSide! !

Object subclass: #CMakeGenerator
	instanceVariableNames: 'output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakeGenerator commentStamp: 'Igor.Stasenko 12/24/2010 02:53' prior: 0!
a base class for generating cmake files.
Mainly provides a helper methods of cmake commands api.!

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:15'!
addDefinitions: aString
	^ self cmd: 'add_definitions' params: aString! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 1/15/2011 16:58'!
addExternalLibraries: libs

	libs do: [:each | self addExternalLibrary: each ]! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'IgorStasenko 6/4/2011 17:01'!
addExternalLibrary: aLibrary 

	self cmd: 'list'
		params: 'APPEND LINKLIBS ' , aLibrary .
		
"	self cmd: 'target_link_libraries' 
		params: self moduleName , ' ' , aLibrary.
"	
! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 1/19/2011 10:22'!
addFrameworks: aCollection 
	"for mac only "
	aCollection
		do: [:each | 
			self cmd: 'find_library' params:  each , '_FMWK ', each.
			self addExternalLibrary: '${', each , '_FMWK}' ]! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 1/10/2011 19:45'!
addProperty: propertyString value: valueString 
	self puts: 'set_target_properties(' , self moduleName , ' PROPERTIES ' , propertyString , ' "' , valueString, '")'
! !

!CMakeGenerator methodsFor: 'sources management' stamp: 'Igor.Stasenko 12/23/2010 13:14'!
addSource: aFileName

	^ self addSources: { aFileName }! !

!CMakeGenerator methodsFor: 'sources management' stamp: 'Igor.Stasenko 12/23/2010 12:09'!
addSources: aFileNames

	^ self addSources: aFileNames prefixed: ''! !

!CMakeGenerator methodsFor: 'sources management' stamp: 'Igor.Stasenko 12/23/2010 13:16'!
addSources: aFileNames prefixed: aPrefix

	| names |
	names := aFileNames inject: '' into: [:res :each | res , ' "' , aPrefix, each, '"' ].
	
	self puts: 'list(APPEND sources ', names , ')'! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:16'!
addSubdirectory: aDir

	^ self cmd: 'add_subdirectory' qparams: aDir. 
! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 1/10/2011 19:46'!
addXCodeProperty: propertyString value: valueString 
	self 
		addProperty: 'XCODE_ATTRIBUTE_' , propertyString 
		value: valueString
! !

!CMakeGenerator methodsFor: 'code generation' stamp: 'Igor.Stasenko 1/14/2011 18:56'!
captureOutputDuring: aBlock
	| old result |
	
	old := output.
	output :=  String new writeStream.
	
	aBlock value.
	
	result := output.
	output := old.
	
	^ result contents! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:18'!
cmd: cmdName params: aString

	output nextPutAll: cmdName;
		nextPut: $(;
		nextPutAll: aString;
		nextPut: $);
		cr
! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:18'!
cmd: cmdName qparams: aString
	"quoted params"
	output nextPutAll: cmdName;
		nextPutAll: '("';
		nextPutAll: aString;
		nextPutAll: '")';
		cr
! !

!CMakeGenerator methodsFor: 'code generation' stamp: 'Igor.Stasenko 12/21/2010 19:02'!
generate
	self subclassResponsibility.! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 1/15/2011 14:53'!
include: aFileName
	^ self cmd: 'include' params: aFileName! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:19'!
includeDirectories: aString
	^ self cmd: 'include_directories' params: aString! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:24'!
message: aString
	
	self cmd: 'message' qparams: aString.! !

!CMakeGenerator methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/10/2011 19:43'!
moduleName
	self subclassResponsibility! !

!CMakeGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/20/2010 01:55'!
outputFileName
	^ 'CMakeLists.txt'! !

!CMakeGenerator methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 18:43'!
printHeader
	
	self puts: '# This is automatically generated file using ', self configurationName, ' on ',
		Date current asString, ' ' , Time current asString;
		puts: 'cmake_minimum_required(VERSION 2.6.2)';
		puts: 'include(CMakeDetermineSystem)'.! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:19'!
project: aProjectName
	self cmd: 'project' qparams: aProjectName
! !

!CMakeGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/20/2010 01:36'!
puts: aString
	output nextPutAll: aString; cr! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:20'!
set: variableName to: aValueString

	self cmd: 'set' params: variableName , ' ' , aValueString! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/20/2010 03:09'!
set: variableName toString: aValueString

	^ self set: variableName to: '"', (aValueString copyReplaceAll: '"' with: '\"'), '"'! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'NicolasPasserini 3/30/2011 14:48'!
setTargetProperties: properties 
	self cmd: 'set_target_properties' params: self moduleName, ' PROPERTIES ', properties ! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 3/23/2011 14:11'!
setTargetProperty: propertyString to: aString
	self 
		cmd: 'set_target_properties'
		params: (String streamContents: [ :stream |
			stream 
				nextPutAll: self moduleName;
				nextPutAll: ' PROPERTIES ';
				nextPutAll: propertyString;
				space;  
				nextPutAll: aString ])! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 3/23/2011 14:12'!
setTargetProperty: propertyString toAll: aCollection
	^self 
		setTargetProperty: propertyString 
		to: (String streamContents: [ :stream | 
			aCollection 
				do: [ :each | stream nextPutAll: each ]
				separatedBy: [ stream nextPut: $, ] ])! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'IgorStasenko 5/7/2011 00:47'!
setTargetProperty: propertyString toString: aString
	self 
		cmd: 'set_target_properties'
		params: (String streamContents: [ :stream |
			stream 
				nextPutAll: self moduleName;
				nextPutAll: ' PROPERTIES ';
				nextPutAll: propertyString;
				space;
				nextPut: $";  
				nextPutAll: (aString copyReplaceAll: '"' with: '\"');
				nextPut: $"
				 ])! !

CMakeGenerator subclass: #CMakePluginGenerator
	instanceVariableNames: 'plugin vmGen internal extraRules doNotGenerate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakePluginGenerator commentStamp: 'Igor.Stasenko 12/25/2010 04:21' prior: 0!
I am using for generating CMakeLists.txt (cmake config files) for specific plugin.
The direct use of my instances is not recommended.
Use CMakeVMGenerator and appropriate configuration to generate both VM and plugins cmake config files.!

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 14:38'!
addCrossSources: sources

	^ self addSources: sources prefixed: '${pluginCross}/'
! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/4/2011 16:57'!
addExternalLibrary: aLibrary 

	self isInternal ifTrue: [
		vmGen addExternalLibrary: aLibrary  
		]
	ifFalse: [ super addExternalLibrary: aLibrary ]
! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 12:51'!
addPlatformSources: sources

	^ self addSources: sources prefixed: '${pluginPlatform}/'
! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 09:52'!
config
	^ vmGen config! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 18:44'!
configurationName
	^ vmGen configurationName! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/27/2010 14:00'!
doNotGenerate

	"Forcely exclude plugin form build. Use this method only for debugging purposes.
	
	Front-end users should simply specify different list of plugins for building VM,
	effectively excluding any unwanted stuff "
	
	^doNotGenerate! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/27/2010 13:59'!
doNotGenerate: aValue

	"Forcely exclude plugin form build. Use this method only for debugging purposes.
	
	Front-end users should simply specify different list of plugins for building VM,
	effectively excluding any unwanted stuff "
	
	doNotGenerate := aValue! !

!CMakePluginGenerator methodsFor: 'code generation' stamp: 'IgorStasenko 7/7/2011 06:55'!
generate

	| name |
	output := String new writeStream.

	name := plugin moduleName.
	self 
		printHeader;
		project: name;
		"include directories generated for build"
		include: '../directories.cmake'.
	
	self set: 'CMAKE_CONFIGURATION_TYPES' to: 'Release'.


	self message: (internal ifTrue: [ 'Adding internal plugin: '] ifFalse: ['Adding external plugin: '])  , name.

	self 
		set: #pluginName toString: name;
		set: #pluginSrc toString: '${srcPluginsDir}/', name;
		set: #pluginCross toString: '${crossDir}/plugins/', name;
		set: #pluginPlatform toString: '${targetPlatform}/plugins/', name.
		
	
	internal 
		ifTrue: [ self puts: 'add_definitions(-DSQUEAK_BUILTIN_PLUGIN)'].
	
	self addSources: { name , '.c' } prefixed: '${pluginSrc}/'.

	" default include directories for plugin "
	self includeDirectories: '${pluginSrc} ${pluginCross} ${targetPlatform}/plugins/${pluginName}'.
	
	self addDefinitions: vmGen config compilerFlags.

	" perform config's configureXYZ: message to apply per-plugin custom rules, if any "
	
	vmGen config configurePlugin: plugin with: self.
	
	extraRules ifNotNil: [ extraRules value: self ].
	
	" generate a static lib for internal plugin, or shared for external"
	internal ifTrue: [
		self cmd: 'add_library' params:  name , ' STATIC ${sources}'.
	] ifFalse: [
		self cmd: 'add_library' params: name , ' SHARED ${sources}'.
		
	"	self cmd: 'set_property' params: 'TARGET ' , name , ' PROPERTY LINK_FLAGS -bundle'"
	].

	vmGen config extraPluginSettings: self.
	
	self isExternal ifTrue: [
		self cmd: 'target_link_libraries'
			params: self moduleName , ' ${LINKLIBS}'.
		].
	
	" see senders of #linkFlags "
	self 
		cmd: 'set_property' 
		params: 'TARGET ', name, ' PROPERTY LINK_FLAGS "${linkFlags}"'.
	
	self saveFile.! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/27/2010 14:02'!
generate: aPlugin for: aCMakeVMGenerator internal: aBoolean extraRules: aBlock

	doNotGenerate := false.
	internal := aBoolean.
	plugin := aPlugin.
	vmGen := aCMakeVMGenerator.
	extraRules := aBlock.
		
	^ self generate! !

!CMakePluginGenerator methodsFor: 'testing' stamp: 'Igor.Stasenko 12/29/2010 15:42'!
isExternal
	^ internal not! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/29/2010 15:42'!
isInternal
	^ internal! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/10/2011 19:43'!
moduleName 
	^plugin moduleName! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/4/2011 22:21'!
saveFile
	
	(((vmGen config dirFrom: vmGen buildDir) / plugin moduleName) assureExistence forceNewFileNamed: self outputFileName) 
		nextPutAll: (self config fixLineEndsOf: output contents); close.
! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 01:07'!
vmGenerator
	"Make it accessible from plugin generator side"
	^ vmGen! !

CMakeGenerator subclass: #CMakeVMGenerator
	instanceVariableNames: 'internalPlugins externalPlugins config'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakeVMGenerator commentStamp: 'Igor.Stasenko 12/25/2010 04:25' prior: 0!
I am generating a cmake configuration file (CMakeLists.txt)
for building a Squeak Virtual Machine.

Usage: 

CMakeVMGenerator new generate: CogMacOSConfig

or

CMakeVMGenerator new generate: (CogMacOSConfig new setOption: ... ; yourself)

you can provide any valid configuration instead of CogMacOSConfig for build. 

Generator creating a '../build' directory (relative to current one)
and placing config files there.
Also, it expects that appropriate VM (re)sources can be found simplarily:
  ../platforms
  ../src
 but these settings are just default ones and could be changed in config
 (see senders of #topDir #buildDir and #srcDir )

Generator and cmake configs are designed so, that any file-system operations are performed in
<build> directory.
So, if you want to build multiple VMs , using same generated sources, but different configs, you can simply
use different build directories.

!

!CMakeVMGenerator class methodsFor: 'code generation' stamp: 'EstebanLorenzano 1/10/2011 19:52'!
generate: aConfigOrClass  
	^self new 
		generate: aConfigOrClass;
		yourself  ! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/22/2010 15:33'!
append: aString toAll: list
	"flatten the list, adding prefix for each element"
	^ list inject: '' into: [:result :each | result, ' ', aString, each ].! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/18/2011 14:56'!
buildDir
	^ config buildDir! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 16:54'!
config
	^ config! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 18:44'!
configurationName
	^ config class name! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 02:04'!
executableName
	^ 'Squeak'! !

!CMakeVMGenerator methodsFor: 'code generation' stamp: 'LucFabresse 12/22/2011 12:00'!
generate
		
	output := String new writeStream.
		
	self printHeader.
	config printExtraHeader: self.
	self project: config executableName.

	config setupDirectories: self.
	self include: 'directories.cmake'.
		
	self message: '${CMAKE_MODULE_PATH}'.
	self set: 'CMAKE_CONFIGURATION_TYPES' to: 'Release'.

	config preferredIncludes 
		do: [ :each | self includeDirectories: each ].
	self includeDirectories: self includeDirs.	
	config standardIncludes 
		do: [:each | self includeDirectories: each ].

	self addDefinitions: config compilerFlags.

	config extraVMSettings: self.
	
	self puts: 'add_executable(' , config executableName, ' ', config executableType, ' ' , self sources , ')'.
		
	self processInternalPlugins.	
	config setExtraTargetProperties: self.
	
	self cmd: 'target_link_libraries'
		params: self moduleName , ' ${LINKLIBS}'.
		
	self processExternalPlugins.
	
	self saveFile.
	! !

!CMakeVMGenerator methodsFor: 'code generation' stamp: 'Igor.Stasenko 12/24/2010 02:06'!
generate: aConfigOrClass
	
	config := aConfigOrClass isBehavior ifTrue: [ aConfigOrClass new ] ifFalse: [aConfigOrClass].
	^ self generate! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 11:53'!
generateExportsH: libs
	| content |
	content := String streamContents: [:str |
	
		str nextPutAll: '/* This is automatically generated file using CVMMaker on ',
			Date current asString, ' ' , Time current asString , ' */'; cr.
		
		str nextPutAll: 
'extern sqExport vm_exports[];
extern sqExport os_exports[];
'.
		libs do: [:each | 
			str nextPutAll: 'extern sqExport ', each ,'_exports [];'; cr ].
		
		str cr; nextPutAll: 'sqExport *pluginExports[] = {
	vm_exports,
	os_exports,
'.

		libs do: [:each | 
			str nextPutAll:  each ,'_exports,'; cr ].
	
		str nextPutAll: 'NULL
};'

	].

	(self buildDir forceNewFileNamed: 'sqNamedPrims.h') nextPutAll: (config fixLineEndsOf: content); close.
	! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/22/2010 01:13'!
generatePlugin: aPlugin internal: aBoolean extraRules: aBlock
	" this method called back from plugin"
	^ CMakePluginGenerator new
		generate: aPlugin for: self internal: aBoolean extraRules: aBlock! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 11:57'!
includeDirs

	^ '${crossDir}/vm ${srcVMDir} ${targetPlatform}/vm ${buildDir}'.! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/22/2010 00:14'!
internalPlugins: intList externalPlugins: extList

	internalPlugins := intList.
	externalPlugins := extList.! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/10/2011 19:43'!
moduleName 
	^config executableName! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 16:47'!
platformName
	^ config platformName
! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/29/2010 15:31'!
processExternalPlugins

	config externalPlugins do: [:each | | plugin gen |
		plugin := Smalltalk at: each.
		gen := plugin generateFor: self internal: false.
		gen doNotGenerate ifFalse: [
			self addSubdirectory: plugin moduleName.
			]
	].
	
! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/29/2010 15:20'!
processInternalPlugins

	| libs |
	libs := OrderedCollection new.

	config internalPlugins collect: [:each | | plugin gen |
		plugin := Smalltalk at: each.
		gen := plugin generateFor: self internal: true.
		gen doNotGenerate ifFalse: [
			libs add: plugin moduleName.
			self addSubdirectory: plugin moduleName.
			 ].
		].
	
	self cmd: 'target_link_libraries' params:  config executableName , ' ' ,
		(libs inject: '' into: [:res :ea | res, ' ' , ea ]) .

	self generateExportsH: libs.
! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/15/2011 14:54'!
saveFile
	
	config write: output contents toFile: (self outputFileName).
	! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/18/2011 10:44'!
sources

	self set: #coreSources to: 
		(self append: '${srcVMDir}/' toAll: config coreSources).
		
	self set: #platformVMSources to: 
		(self append: '${targetPlatform}/vm/' toAll: config platformSources).
	
	
	self set: #crossVMSources to: 
		(self append: '${crossDir}/vm/' toAll: config crossSources).
		
	self set: #extraSources to: config extraSources.
	
	^ '${coreSources} ${crossVMSources} ${platformVMSources} ${extraSources}'! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/24/2010 20:09'!
targetPropertyAt: aPropName put: aValue
	"set target's properties"
	
	self cmd: 'set_property' params: 'TARGET ', config executableName , 
	' PROPERTY ', aPropName , ' ' , aValue.
! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/24/2010 20:13'!
targetPropertyAt: aPropName qput: aValue
	"set target's properties, put value in quotes"
	
	^ self targetPropertyAt: aPropName put: (aValue copyReplaceAll: '"' with: '\"').! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 03:22'!
topDir
	| dir |
	dir := self config topDir ifNil: [ FileDirectory default containingDirectory ].
	dir isString ifTrue: [^ FileDirectory on: ( FileDirectory fullPathForURI: dir) ].
	^ dir! !

Object subclass: #CPlatformConfig
	instanceVariableNames: 'topDir buildDir srcDir platformsDir outputDir internalPlugins externalPlugins pluginsDir externalLibs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CPlatformConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:29' prior: 0!
Base class, defining some common properties and behavior for all kinds of VM build configurations. These classes are used to generate the VM sources and the CMMake files. 

Notice that this configuration classes expect that you have download the "platofroms code" which is in Gitorious: https://gitorious.org/cogvm
You can load it executing: git clone git://gitorious.org/cogvm/blessed.git

Once that is done it should have created a directory /blessed. In order to get all the directories by default, place this image under /blessed/image 

To generate a sources/build configuration use one of my subclasses with:
<config> generate.   - to generate a build configuration
<config> generateWithSources - to generate VMMaker sources and then build configuration.

Once you do that, go to /blessed/build and execute:  cmake .    or cmake -G"MSYS Makefiles" if you are in Windows 

Since some plugins require extra settings (like additional source files etc), there is two ways to add that:

- add custom rules on plugin class side:

PluginClass>>generateFor: aCMakeVMGenerator internal: aBoolean 

	^ aCMakeVMGenerator 
		generatePlugin: self 
		internal: aBoolean
		extraRules: [:maker |   ... your rules come here ... ]
		
- define rules by adding #configure<PluginClass>: method in config class (see my 'plugin extra rules' category)

The last one is more compact and also avoids inter-package dependency, so you can load and use
CMakeVMMaker even if some 3rd-party plugins are not loaded into image.


Links of interest:

Official Cog Website: http://www.mirandabanda.org/cog
Official Cog Blog: http://www.mirandabanda.org/cogblog
Cog issue tracker: http://code.google.com/p/cog
Cog Wiki: http://code.google.com/p/cog/w/list
Cog binaries: http://www.mirandabanda.org/files/Cog/VM
Cog binaries in Pharo Hudson server: https://pharo-ic.lille.inria.fr/hudson/view/Cog
Cog SVN branch: http://squeakvm.org/svn/squeak/branches/Cog
VM mailing list: http://lists.squeakfoundation.org/mailman/listinfo/vm-dev
VM-beginners mailing list: http://lists.squeakfoundation.org/mailman/listinfo/vm-beginners
Guide step by step about how to build the Cog VM using CMakeVMMaker and Git: http://code.google.com/p/cog/wiki/Guide



!

!CPlatformConfig class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/18/2011 00:59'!
generate

	^ self new generate! !

!CPlatformConfig class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/18/2011 00:58'!
generateWithSources

	^ self new generateSources; generate.
! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'IgorStasenko 7/6/2011 05:01'!
addExternalPlugin: aPluginName

	| plugins |
	plugins := self externalPlugins.
	(self internalPlugins includes: aPluginName) ifTrue: [
		self error: 'Cannot add plugin ', aPluginName , ' as external, because it is already included as internal one'
		].
	(plugins includes: aPluginName) ifFalse: [ externalPlugins := externalPlugins copyWith: aPluginName ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'IgorStasenko 7/6/2011 04:58'!
addExternalPlugins: aPluginNames

	aPluginNames do: [:each | self addExternalPlugin: each ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'IgorStasenko 7/6/2011 05:01'!
addInternalPlugin: aPluginName

	| plugins |
	plugins := self internalPlugins.

	(self externalPlugins includes: aPluginName) ifTrue: [
		self error: 'Cannot add plugin ', aPluginName , ' as internal, because it is already included as external one'
		].
	
	(plugins includes: aPluginName) ifFalse: [ internalPlugins := internalPlugins copyWith: aPluginName ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'IgorStasenko 7/6/2011 04:58'!
addInternalPlugins: aPluginNames

	aPluginNames do: [:each | self addInternalPlugin: each ]! !

!CPlatformConfig methodsFor: 'directories' stamp: 'MarianoMartinezPeck 4/12/2011 21:56'!
buildDir
	
	^ buildDir ifNil: [ buildDir := (self topDir / self buildDirName) assureExistence ].
! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/4/2011 23:04'!
buildDir: anObject
	"Set the value of buildDir"

	buildDir := self dirFrom: anObject! !

!CPlatformConfig methodsFor: 'directories' stamp: 'MarianoMartinezPeck 4/12/2011 21:56'!
buildDirName
	^ 'build'
! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:30'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ nil! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:15'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	maker 
		addCrossSources: #( 'sqOpenGLRenderer.c' ) 
	
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/27/2010 14:00'!
configureBochsIA32Plugin: maker

	"this stuff is not ready for use yet" 
	
" 	maker addCrossSources:
		#( 'sqBochsIA32Plugin.cpp'  )

"
	maker doNotGenerate:true! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 6/22/2011 20:26'!
configureCroquetPlugin: maker 
	"extra rules for CroquetPlugin"
	maker addCrossSources: #('TriBoxStub.c').! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:16'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:17'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	" it is incomplete right now, because in Cog this plugin are not used anymore"
	maker doNotGenerate: true.
	maker addCrossSources: #('sqFFIPlugin.c').! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 6/14/2011 14:42'!
configureFT2Plugin: maker 
	"extra rules for FT2Plugin"

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:17'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	maker addCrossSources: #( 'sqFilePluginBasicPrims.c').
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/5/2011 01:49'!
configureFloatMathPlugin: maker
	"extra rules for FloatMathPlugin"

	maker addCrossSources: #(
		'acos.c' 'acosh.c' 'asin.c' 'asinh.c' 'atan.c' 'atan2.c' 'atanh.c'
		'copysign.c' 'cos.c' 'cosh.c' 'exp.c' 'expm1.c' 'finite.c' 'fmod.c'
		'hypot.c' 'isnan.c' 'k_cos.c' 'k_rem_pio2.c' 'k_sin.c' 'k_tan.c' 'ldexp.c'
		'log.c' 'log10.c' 'log1p.c' 'modf.c' 'pow.c' 'rem_pio2.c' 'rint.c'
		'scalb.c' 'scalbn.c' 'sin.c' 'sinh.c' 'sqrt.c' 'tan.c' 'tanh.c' ).

	
	"according to http://www.netlib.org/fdlibm/readme
	it should be compiled with no optimizations"
	maker addDefinitions: '-O0'.
	
	" compile with -D__LITTLE_ENDIAN
		This macro is set automatically in fdlibm.h when compiled ith -m32 but
		not when compiled with -m64 (Nicolas Cellier)
	"
	self isLittleEndian ifTrue: [
		maker addDefinitions: '-D__LITTLE_ENDIAN=1' ].
	
	"On *nix & mac with -DNO_ISNAN "
	maker puts:'
if (${WIN32})
	add_definitions(-Werror-implicit-function-declaration)	
else(${WIN32})
	add_definitions(-DNO_ISNAN)
endif (${WIN32})'.

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:18'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:32'!
configureIA32ABIPlugin: maker
	"extra rules for IA32ABIPlugin"

	maker addCrossSources:
		#( 'ia32abicc.c')
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:18'!
configureInternetConfigPlugin: maker
	"extra rules for InternetConfigPlugin"! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:34'!
configureJPEGReadWriter2Plugin: maker 
	"extra rules for JPEGReadWriter2Plugin"

maker addCrossSources: #(
'Error.c'
'jcapimin.c'
'jcapistd.c'
'jccoefct.c'
'jccolor.c'
'jcdctmgr.c'
'jchuff.c'
'jcinit.c'
'jcmainct.c'
'jcmarker.c'
'jcmaster.c'
'jcomapi.c'
'jcparam.c'
'jcphuff.c'
'jcprepct.c'
'jcsample.c'
'jctrans.c'
'jdapimin.c'
'jdapistd.c'
'jdatadst.c'
'jdatasrc.c'
'jdcoefct.c'
'jdcolor.c'
'jddctmgr.c'
'jdhuff.c'
'jdinput.c'
'jdmainct.c'
'jdmarker.c'
'jdmaster.c'
'jdmerge.c'
'jdphuff.c'
'jdpostct.c'
'jdsample.c'
'jdtrans.c'
'jerror.c'
'jfdctflt.c'
'jfdctfst.c'
'jfdctint.c'
'jidctflt.c'
'jidctfst.c'
'jidctint.c'
'jidctred.c'
'jmemdatadst.c'
'jmemdatasrc.c'
'jmemmgr.c'
'jmemnobs.c'
'jquant1.c'
'jquant2.c'
'jutils.c'
) 
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:19'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/15/2011 15:38'!
configureMpeg3Plugin: maker
	"extra rules for Mpeg3Plugin"

	maker includeDirectories: '${pluginCross}/libmpeg ${pluginCross}/libmpeg/audio ${pluginCross}/libmpeg/video'.

	maker addCrossSources: 
		#( 
		'libmpeg/bitstream.c' 
		'libmpeg/changesForSqueak.c'
		'libmpeg/audio/dct.c'
		'libmpeg/video/getpicture.c'
		'libmpeg/audio/header.c'
		'libmpeg/video/headers.c'
		'libmpeg/video/idct.c'
		'libmpeg/audio/layer1.c'
		'libmpeg/audio/layer2.c'
		'libmpeg/audio/layer3.c'
		'libmpeg/libmpeg3.c'
		'libmpeg/video/macroblocks.c'
		'libmpeg/video/mmxtest.c'
		'libmpeg/video/motion.c'
		'libmpeg/mpeg3atrack.c'
		'libmpeg/audio/mpeg3audio.c'
		'libmpeg/mpeg3demux.c'
		'libmpeg/mpeg3io.c'
		'libmpeg/mpeg3title.c'
		'libmpeg/video/mpeg3video.c'
		'libmpeg/mpeg3vtrack.c'
		'libmpeg/video/output.c'
		'libmpeg/audio/pcm.c'
		'libmpeg/video/reconstruct.c'
		'libmpeg/video/seek.c'
		'libmpeg/video/slice.c'
		
		'libmpeg/audio/synthesizers.c'
		'libmpeg/audio/tables.c'
		'libmpeg/video/vlc.c'
	).
	
	
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/29/2010 15:41'!
configurePlugin: aPlugin with: generator

	^ self perform: ( 'configure' , aPlugin name , ':' ) asSymbol with: generator.
	! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:37'!
configureRePlugin: maker 
	"extra rules for RePlugin"

	maker addCrossSources: #(
		'pcre.c' 'study.c' 'get.c' 'chartables.c').
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/15/2011 17:25'!
configureReentrantIA32FFIPlugin: maker
	"extra rules for ReentrantIA32FFIPlugin"
	
	maker addCrossSources: #(
		'sqFFIPlugin.c' 'sqFFITestFuncs.c' 'sqManualSurface.c'
	).

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:21'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/3/2011 14:19'!
configureSocketPlugin: maker 
	"extra rules for SocketPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:40'!
configureSoundCodecPlugin: maker 
	"extra rules for SoundCodecPlugin"

	maker addCrossSources:
		#( 'sqSoundCodecPluginBasicPrims.c' )


! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 8/9/2011 14:39'!
configureSoundGenerationPlugin: maker 
	"extra rules for SoundPlugin"

	maker doNotGenerate: true. 
	" The sources in platforms/Cross/plugins/SoundGenerationPlugin/sqOldSoundPrims.c 
	are out of date and need to be fixed before it can be built 
	
	
	maker 
		addCrossSources: #('sqOldSoundPrims.c') 

	"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:21'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:41'!
configureSurfacePlugin: maker 
	"extra rules for SurfacePlugin"

	maker set: #sources toString: ''. "remove default source file"
	maker addCrossSources: #('SurfacePlugin.c')


! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 23:40'!
configureThreadedIA32FFIPlugin: maker
	"extra rules for ThreadedIA32FFIPlugin"
	
	maker addCrossSources: #(
		'sqFFIPlugin.c' 'sqFFITestFuncs.c' 'sqManualSurface.c'
	).

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:23'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/31/2010 01:12'!
configureUnixOSProcessPlugin: maker
	"extra rules for UnixOSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	
	
	
	"THIS IS UGLY AND LAME!!!!!! "
	maker set: #linkFlags toString: '-undefined dynamic_lookup'! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:03'!
coreSources
	^#()! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 10:52'!
crossSources 
	^#(
			'sqHeapMap.c'
			'sqTicker.c'
			'sqExternalSemaphores.c'
			'sqNamedPrims.c'
			'sqVirtualMachine.c'
		)! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:19'!
defaultExternalPlugins
	self shouldBeImplemented ! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:18'!
defaultInternalPlugins
	self shouldBeImplemented ! !

!CPlatformConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 1/14/2011 16:46'!
dirFrom: aStringOrDir
	
	^ aStringOrDir isString ifTrue: [
		FileDirectory on: ( FileDirectory fullPathForURI: aStringOrDir)] 
	ifFalse: [ aStringOrDir ]! !

!CPlatformConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 12/25/2010 03:48'!
doesNotUnderstand: aMessage
	" ignore configureXYZ: messages "

	| sel  |
	sel := aMessage selector.
	
	((sel beginsWith: 'configure') and: [
		(sel indexOf: $: ) = sel size ] ) ifTrue: [ ^ self ].
	
	^ super doesNotUnderstand: aMessage! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/23/2010 19:53'!
executableName
	"default one"
	^ 'Squeak'! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/23/2010 22:44'!
executableType
	^ ''! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:16'!
externalPlugins
	^ externalPlugins ifNil: [ externalPlugins := self defaultExternalPlugins ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:18'!
externalPlugins: aColl

	externalPlugins := aColl! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/15/2011 15:34'!
extraPluginSettings: maker
	"override in subclasses to apply extra settings for all plugins targets"! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:04'!
extraSources
	^''! !

!CPlatformConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 12/23/2010 11:54'!
fixLineEndsOf: string
	^ string ! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 00:52'!
frameworks
	"leave empty for all platforms but Mac OS"
	^ #()! !

!CPlatformConfig methodsFor: 'public' stamp: 'IgorStasenko 3/5/2011 14:17'!
generate
	^ CMakeVMGenerator generate: self ! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 6/29/2011 07:15'!
generateSources
	"Generate whole VM + plugins sources"
	| maker |

	self validateSourcesPresent.
	self prepareForGeneration.
	
	"suppress questions and deprecation warnings during generation "
	[[
		
		maker := self prepareVMMaker.
	
		maker interpreterClass: self interpreterClass.
		self cogitClass ifNotNil: [:cg | 
			maker cogitClass: cg.
			"this is ugly, before VMMaker will be fixed to initialize stuff properly"
			Cogit initializeCompilationConstants.
			cg initializeWithOptions: (maker instVarNamed: 'optionsDictionary')
		].
		
		maker generateEntire

	] on: ProvideAnswerNotification do: [:ex | ex resume: true ]]
	on: Deprecation do: [:ex | ex resume ].
	
	
! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 5/10/2011 14:09'!
generateVMOnlySources
	"Generate source code for VM only, without plugins"
	| maker |

	self validateSourcesPresent.
	self prepareForGeneration.
	
	"suppress questions and deprecation warnings during generation "
	[[
		
		maker := self prepareVMMaker.
	
		maker interpreterClass: self interpreterClass.
		self cogitClass ifNotNil: [:cg | maker cogitClass: cg ].

	
		maker generateMainVM

	] on: ProvideAnswerNotification do: [:ex | ex resume: true ]]
	on: Deprecation do: [:ex | ex resume ].
	

! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:16'!
internalPlugins
	^ internalPlugins ifNil: [ internalPlugins := self defaultInternalPlugins ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:18'!
internalPlugins: aColl

	internalPlugins := aColl! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:25'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	self subclassResponsibility ! !

!CPlatformConfig methodsFor: 'testing' stamp: 'Igor.Stasenko 12/30/2010 22:29'!
isLittleEndian
	"default is true. Override if necessary"
	^ true! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/20/2011 14:16'!
linkFlags 
	^''! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:26'!
outputDir: anObject
	"Set the value of outputDir"

	outputDir := anObject! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 22:00'!
outputDirName
	^ 'results'! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:03'!
platformSources
	^#()! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:54'!
platformsDir 
	"Answer the value of srcDir"

	^ platformsDir ifNil: [ platformsDir := (self topDir / self platformsDirName) fullName ]
	! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 03:37'!
platformsDir: anObject
	"Set the value of platformsDir"

	platformsDir := anObject! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:54'!
platformsDirName
	^ 'platforms'! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/2/2011 12:03'!
pluginsDir 
	^pluginsDir
! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/14/2011 16:48'!
pluginsDir: aStringOrDir
	"Set the value of topDir"

	pluginsDir := self dirFrom: aStringOrDir.
	! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 21:14'!
preferredIncludes
	^#()! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:28'!
prepareForCogGeneration.
	"make sure these classes are initialized properly "	
	CogRTLOpcodes initialize.
	CogIA32Compiler initialize.
	
! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:26'!
prepareForGeneration
	self subclassResponsibility ! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:35'!
prepareForStackVMGeneration
	"make sure these classes are initialized properly "	
		
	StackInterpreter initialize
! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'MarianoMartinezPeck 4/19/2011 13:20'!
prepareVMMaker

	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!CPlatformConfig methodsFor: 'utils' stamp: 'LucFabresse 12/22/2011 12:02'!
printExtraHeader: maker! !

!CPlatformConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 1/15/2011 17:00'!
setExtraTargetProperties: maker

! !

!CPlatformConfig methodsFor: 'directories' stamp: 'IgorStasenko 7/5/2011 01:26'!
setupDirectories: gen
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil: [self buildDir fullName] );
			set: #platformsDir toString: self platformsDir;
			set: #srcDir toString: self srcDir;
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: self outputDir.
	].

	self write: dirsInclude toFile: 'directories.cmake'! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:49'!
srcDir
	"Answer the value of srcDir"

	^ srcDir ifNil: [ srcDir := (self topDir / self srcDirName) assureExistence fullName ]! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/4/2011 22:00'!
srcDir: aStringOrDir
	"Set the value of topDir"

	srcDir :=  aStringOrDir.
	! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:49'!
srcDirName
	^ 'src'! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:04'!
standardIncludes 
	^#()! !

!CPlatformConfig methodsFor: 'directories' stamp: 'Igor.Stasenko 1/15/2011 15:21'!
topDir
	
	^ topDir ifNil: [ topDir := FileDirectory default containingDirectory ].
! !

!CPlatformConfig methodsFor: 'directories' stamp: 'Igor.Stasenko 1/14/2011 17:22'!
topDir: pathString

	topDir :=
		FileDirectory on: (FileDirectory fullPathForURI: pathString).
	topDir assureExistence.! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'MarianoMartinezPeck 4/3/2011 12:10'!
validateSourcesPresent
	| sources |
	sources := FileDirectory openSources: SmalltalkImage current sourcesName forImage: SmalltalkImage current imageName.
	
	((sources == nil or: [sources atEnd])
			and: [ SmalltalkImage current checkSourcesFileAvailability])
		ifTrue: [
		self error: 'VM source code cannot be generated without .sources file'.
	]		! !

!CPlatformConfig methodsFor: 'directories' stamp: 'Igor.Stasenko 1/15/2011 15:22'!
write: aContents toFile: aFileName

	"write a file to current output directory (buildDir).
	use line end convention appropriate for config platform"
	

	| bldDir |
	
	bldDir := self buildDir.
	
 	bldDir isString ifTrue: [ bldDir := FileDirectory on: (FileDirectory fullPathForURI: bldDir) ].
	bldDir assureExistence.
	
	bldDir forceNewFileNamed: aFileName 
		do: [:stream | stream nextPutAll: (self fixLineEndsOf: aContents) ].! !

CPlatformConfig subclass: #CogFamilyUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogFamilyUnixConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:31' prior: 0!
This is an abstract class for all Cog VMs for Unix. 

For ALSA sound driver you need to install a 

 - libasound2
 - libasound2-dev

For UUID you might also need: 

- uuid-dev
 packages  


Fore more information, check the class comments of all the superclasses.
!

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'NicolasPasserini 3/30/2011 16:45'!
addDriver: name sources: aSources generator: cmakeGen

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS "', self linkFlags , '"'
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'IgorStasenko 8/15/2011 10:36'!
addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			addExternalLibraries: extLibs;
			cmd: 'target_link_libraries' params: name , ' ${LINKLIBS}';
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS -m32' 
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'IgorStasenko 7/7/2011 16:09'!
addVMDrivers: maker
"
libICE
ICE is the Inter Client Exchange protocol, part of X11

libSM
session management library for X11

"
	 self 
		addDriver: 'vm-display-null' 
		sources: #( 
			'${targetPlatform}/vm-display-null/sqUnixDisplayNull' )
		generator: maker
		externalLibs: #();
		
		
		addDriver: 'vm-display-X11' 
		sources: #( 
			'${targetPlatform}/vm-display-X11/sqUnixX11'
			'${targetPlatform}/vm-display-X11/sqUnixMozilla' )
		generator: maker
		
		"-lSM -lICE -ldl -lGL -lpthread -lm -lnsl -lX11'"
		externalLibs: #( SM ICE GL X11 nsl dl);
		

		addDriver: 'vm-sound-ALSA' 
		sources: #( 
			'${targetPlatform}/vm-sound-ALSA/sqUnixSoundALSA' )
		generator: maker
		externalLibs: #();

		addDriver: 'vm-sound-null' 
		sources: #( 
			'${targetPlatform}/vm-sound-null/sqUnixSoundNull' )
		generator: maker
		externalLibs: #().
	
"
vm-display-null
	vm-display-X11
	vm-sound-ALSA
	vm-sound-null"! !

!CogFamilyUnixConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 2/12/2011 21:56'!
compilerFlags
	^ self subclassResponsibility! !

!CogFamilyUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/16/2011 01:28'!
configureAsynchFilePlugin: maker

	maker addPlatformSources:
	#( 
		'sqUnixAsynchFile.c'
	)

! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 14:29'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker.
	
	maker 
		addPlatformSources: #( 'sqUnixOpenGL.c' ) 
		
! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:50'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker includeDirectories: '${crossDir}/plugins/FilePlugin'. 
	maker addPlatformSources: #( 'sqUnixDragDrop')
! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 6/14/2011 15:07'!
configureFT2Plugin: maker 
	"extra rules for FT2Plugin" 
	
	maker addExternalLibraries: #('freetype' ).
	
	"
	ft2build.h. says: 
	<prefix>/include/freetype2' must be in your current inclusion path "
	maker includeDirectories:  '/usr/include/freetype2'! !

!CogFamilyUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/16/2011 01:59'!
configureFileCopyPlugin: maker
	"extra rules for DropPlugin"

	maker addPlatformSources: #( 'sqUnixFileCopyPlugin')
! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:31'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker addPlatformSources: #( 'sqUnixFile')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:34'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 'sqUnixJoystickTablet' )
! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/7/2011 17:09'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"

	super configureLocalePlugin:  maker.
	
	maker addPlatformSources: #( 'sqUnixLocale.c')
	! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:37'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureMIDIPlugin: maker.  

	"requires ALSA"

	maker addPlatformSources: #( 'sqUnixMIDI')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:38'!
configureSecurityPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureSecurityPlugin: maker.
	
	maker addPlatformSources: #( 'sqUnixSecurity')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:40'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"
	
	maker addPlatformSources: #( 'sqUnixSerial')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:41'!
configureSocketPlugin: maker 
	"extra rules for SocketPlugin"
	
	maker addPlatformSources: #( 'sqUnixSocket')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:42'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"
	
	maker addPlatformSources: #( 'sqUnixSound')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/15/2011 17:56'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	
	maker includeDirectories: '/usr/include/uuid'.
	
	maker addPlatformSources:
		#( 'sqUnixUUID.c')


! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/6/2011 16:25'!
configureUnixOSProcessPlugin: maker 
	"extra rules for UnixOSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker includeDirectories: '${crossDir}/plugins/SocketPlugin'.
	
	maker addDefinitions: '-DSQAIO_H=\"sqaio.h\"'
! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/6/2011 16:11'!
extraPluginSettings: maker

	maker isExternal ifTrue: [
		"copy lib to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' to: '${outputDir}' 
	].
! !

!CogFamilyUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/18/2011 10:48'!
extraVMSettings: maker
	| versionC |
	self generateConfigH.
	
	"add a generated version.c"
	
	versionC := 'version.c'.
	
	maker cmd: 'add_custom_command' params: 'OUTPUT ',
		versionC , '
		COMMAND ${platformsDir}/unix/config/verstamp ',versionC,' gcc
		COMMENT "Generating version.c"
	'.
	
	! !

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 1/18/2011 10:16'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String lf! !

!CogFamilyUnixConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/4/2011 02:37'!
frameworks
	^ #()! !

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'NicolasPasserini 3/30/2011 16:46'!
linkFlags
	 ^ '-lSM -lICE -ldl -lGL -lpthread -lm -lnsl -lX11'! !

!CogFamilyUnixConfig methodsFor: 'directories' stamp: 'MarianoMartinezPeck 4/12/2011 22:00'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self buildDir containingDirectory fullName , '/', self outputDirName) ]
	! !

!CogFamilyUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/4/2011 02:38'!
platformName
	^ 'unix'! !

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'IgorStasenko 2/9/2011 19:04'!
setExtraTargetProperties: maker


	maker addExternalLibraries: 
		#(
			'm'  "math lib"
			'dl'  "dynamic loader"
			'pthread' "posix threads" 
		).
		
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
	self addVMDrivers: maker.! !

CogFamilyUnixConfig subclass: #CogUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogUnixConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:31' prior: 0!
Base and concrete configuration for building a CogVM on Unix platform(s).

Usage: 
CogUnixConfig generateWithSources
or
CogUnixConfig generate   "if VMMaker sources already there"


Fore more information, check the class comments of all the superclasses.
!

CogUnixConfig subclass: #CogFreeBSDConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-FreeBSD'!

!CogFreeBSDConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is the base and concrete configuration for building Cog VM on FreeBSD platform(s).

Fore more information, check the class comments of all the superclasses.
!

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/26/2011 05:08'!
addDriver: name sources: aSources generator: cmakeGen

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS "-pthread -lm"'
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/25/2011 21:09'!
addVMDrivers: maker

	 self 
		addDriver: 'vm-display-null' 
		sources: #( 
			'${targetPlatform}/vm-display-null/sqUnixDisplayNull' )
		generator: maker;
		
		addDriver: 'vm-display-X11' 
		sources: #( 
			'${targetPlatform}/vm-display-X11/sqUnixX11'
			'${targetPlatform}/vm-display-X11/sqUnixMozilla' )
		generator: maker;
		
		addDriver: 'vm-sound-null' 
		sources: #( 
			'${targetPlatform}/vm-sound-null/sqUnixSoundNull' )
		generator: maker.
	
"
vm-display-null
	vm-display-X11
	vm-sound-null"! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/26/2011 04:57'!
compilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ super compilerFlags, ' -I/usr/local/include'! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/26/2011 20:45'!
compilerFlagsDebug

	^ '-g3 -O0 -msse2 -DITIMER_HEARTBEAT=1 
	-DNO_VM_PROFILE=1 -DDEBUGVM=1 -DNOEXECINFO'! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/26/2011 20:47'!
compilerFlagsRelease

	^ '-g0 -O2 -msse2  -DNDEBUG -DITIMER_HEARTBEAT=1 
	-DNO_VM_PROFILE=1 -DDEBUGVM=0 -DNOEXECINFO'
! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/25/2011 21:22'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define HAVE_INTERP_H 1

/* package options */

#define USE_X11 1
#define USE_X11_GLX 1
/* #undef       USE_QUARTZ */
/* #undef       USE_QUARTZ_CGL */
/* #undef       USE_RFB */

/* libraries */

/* #undef       HAVE_LIBX11 */
#define HAVE_LIBXEXT 1
#define HAVE_LIBDL 1
/* #undef       HAVE_DYLD */
/* #undef       HAVE_LIBFFI */
/* #undef       HAVE_ICONV */

/* #undef       USE_AUDIO_NONE */
/* #undef       USE_AUDIO_SUN */
/* #undef       USE_AUDIO_NAS */
/* #undef       USE_AUDIO_OSS */
/* #undef       USE_AUDIO_MACOSX */
/* #undef       OSS_DEVICE */

/* header files */

#define HAVE_UNISTD_H 1
/* #undef       NEED_GETHOSTNAME_P */

#define HAVE_DIRENT_H 1
/* #undef       HAVE_SYS_NDIR_H */
/* #undef       HAVE_SYS_DIR_H */
/* #undef       HAVE_NDIR_H */
#define HAVE_DLFCN_H 1
/* #undef       HAVE_ICONV_H */

#define HAVE_SYS_TIME_H 1
#define TIME_WITH_SYS_TIME 1

#define HAVE_SYS_FILIO_H 1

/* #undef       HAVE_SYS_AUDIOIO_H */
/* #undef       HAVE_SUN_AUDIOIO_H */

/* #undef       HAVE_PTY_H */
/* #undef       HAVE_UTIL_H */
#define HAVE_LIBUTIL_H 1
/* #undef       HAVE_STROPTS_H */

#define HAVE_GL_GL_H 1
/* #undef       HAVE_OPENGL_GL_H */

/* #undef       NEED_SUNOS_H */


#define HAVE_UUID_H
/* system calls/library functions */

#define AT_EXIT atexit

#define HAVE_TZSET 1

#define HAVE_OPENPTY 1
/* #undef       HAVE_UNIX98_PTYS */

#define HAVE_SNPRINTF 1
/* #undef       HAVE___SNPRINTF */

#define HAVE_MMAP 1

/* #undef       HAVE_DYLD */

#define HAVE_LANGINFO_CODESET 1

#define HAVE_ALLOCA 1
/* #undef       HAVE_ALLOCA_H */

#define HAVE_UNSETENV 1

#define HAVE_NANOSLEEP 1

/* widths of primitive types */

#define SIZEOF_INT 4
#define SIZEOF_LONG 4
#define SIZEOF_LONG_LONG 8
#define SIZEOF_VOID_P 4

/* structures */

#define HAVE_TM_GMTOFF 1
#define HAVE_TIMEZONE 1

/* typedefs */

/* #undef       size_t */
/* #undef       socklen_t */

#define squeakInt64 long long

/* architecture */

#define OS_TYPE "unix"

#define VM_HOST "i386-freebsd8.2"
#define VM_HOST_CPU "i386"
/* #undef       VM_HOST_VENDOR */
#define VM_HOST_OS "freebsd8.2"
#define VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef       WORDS_BIGENDIAN */
/* #undef       DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef       DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR "/usr/X11R6/lib"

/* avoid dependencies on glibc2.3 */

/* #undef HAVE_FEATURES_H */

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/25/2011 18:13'!
configureFloatMathPlugin: maker
	"extra rules for FloatMathPlugin"

	maker addCrossSources: #(
		'acos.c' 'acosh.c' 'asin.c' 'asinh.c' 'atan.c' 'atan2.c' 'atanh.c'
		'copysign.c' 'cos.c' 'cosh.c' 'exp.c' 'expm1.c' 'finite.c' 'fmod.c'
		'hypot.c' 'isnan.c' 'k_cos.c' 'k_rem_pio2.c' 'k_sin.c' 'k_tan.c' 'ldexp.c'
		'log.c' 'log10.c' 'log1p.c' 'modf.c' 'pow.c' 'rem_pio2.c' 'rint.c'
		'scalb.c' 'scalbn.c' 'sin.c' 'sinh.c' 'sqrt.c' 'tan.c' 'tanh.c' ).

	
	"according to http://www.netlib.org/fdlibm/readme
	it should be compiled with no optimizations
	# 3/25/11 - DSG Removed -mno-fused-madd
	since FreeBSD will not support > GCC42"
	maker addDefinitions: '-O0'.
	
	" compile with -D__LITTLE_ENDIAN
		This macro is set automatically in fdlibm.h when compiled ith -m32 but
		not when compiled with -m64 (Nicolas Cellier)
	"
	self isLittleEndian ifTrue: [
		maker addDefinitions: '-D__LITTLE_ENDIAN=1' ].
	
	"On *nix & mac with -DNO_ISNAN "
	maker puts:'
if (${WIN32})
	add_definitions(-Werror-implicit-function-declaration)	
else(${WIN32})
	add_definitions(-DNO_ISNAN)
endif (${WIN32})'.

! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/26/2011 03:36'!
setExtraTargetProperties: maker


	maker addExternalLibraries: 
		#(
			'm'  "math lib"
			'pthread' "posix threads" 
		).
		
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
	self addVMDrivers: maker.! !

CogFreeBSDConfig subclass: #CogMTFreeBSDConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-FreeBSD'!

!CogMTFreeBSDConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for FreeBSD. This VM is normally known as CogMTVM.

Fore more information, check the class comments of all the superclasses.
!

!CogMTFreeBSDConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/23/2011 15:34'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ ' -DLSB_FIRST=1 -DUSE_GLOBAL_STRUCT=0 -DCOGMTVM=1'	
	! !

!CogMTFreeBSDConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/23/2011 15:34'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!CogMTFreeBSDConfig methodsFor: 'sources' stamp: 'IgorStasenko 3/23/2011 15:34'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!CogMTFreeBSDConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/23/2011 15:34'!
defaultExternalPlugins

	^ #(
		B3DAcceleratorPlugin
		UUIDPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		"UnixOSProcessPlugin ?? "
	)! !

!CogMTFreeBSDConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:34'!
executableName
	^ 'CogMTVM'! !

!CogMTFreeBSDConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/23/2011 15:34'!
interpreterClass
	^ CoInterpreterMT! !

CogFreeBSDConfig subclass: #StackFreeBSDConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-FreeBSD'!

!StackFreeBSDConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is a concrete class which generates a StackVM for FreeBSD.

Fore more information, check the class comments of all the superclasses.
!

!StackFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/23/2011 15:37'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackFreeBSDConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/23/2011 15:37'!
interpreterClass
	^ StackInterpreter! !

!StackFreeBSDConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

CogUnixConfig subclass: #CogMTUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogMTUnixConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Unix. This VM is normally known as CogMTVM.

Fore more information, check the class comments of all the superclasses.
!

!CogMTUnixConfig methodsFor: 'compiler flags' stamp: 'NicolasPasserini 3/30/2011 17:02'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ ' -DLSB_FIRST=1 -DUSE_GLOBAL_STRUCT=0 -DCOGMTVM=1 -m32' 	
	! !

!CogMTUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/19/2011 23:56'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!CogMTUnixConfig methodsFor: 'sources' stamp: 'IgorStasenko 3/19/2011 23:56'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!CogMTUnixConfig methodsFor: 'plugins' stamp: 'NicolasPasserini 3/30/2011 17:19'!
defaultExternalPlugins

	^ #(
		B3DAcceleratorPlugin
		"UUIDPlugin"
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		"UnixOSProcessPlugin ?? "
	)! !

!CogMTUnixConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:24'!
executableName
	^ 'CogMTVM'! !

!CogMTUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/19/2011 23:56'!
interpreterClass
	^ CoInterpreterMT! !

CogUnixConfig subclass: #CogOnDebian64Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogOnDebian64Config commentStamp: 'LaurentLaffont 8/15/2011 15:30' prior: 0!
Used to build 32 bit Cog on Debian 64 bits.

You need to prepare Debian this way:

apt-get install ia32-libs libc6-dev-i386 gcc-multilib g++-multilib

ln -s /usr/lib32/libSM.so.6 /usr/lib32/libSM.so
ln -s /usr/lib32/libICE.so.6 /usr/lib32/libICE.so
ln -s /usr/lib32/libGL.so.1 /usr/lib32/libGL.so
ln -s /usr/lib32/libX11.so.6 /usr/lib32/libX11.so

Then you can go on CogOnDebian64Config generateWithSources.

!

!CogOnDebian64Config methodsFor: 'accessing' stamp: 'LaurentLaffont 8/15/2011 08:44'!
commonCompilerFlags 
	^ super commonCompilerFlags , ' -L/usr/lib32'! !

!CogOnDebian64Config methodsFor: 'accessing' stamp: 'LaurentLaffont 8/15/2011 08:36'!
linkFlags 
	^ super linkFlags , ' -L/usr/lib32'! !

!CogUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:38'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'NicolasPasserini 3/30/2011 14:08'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ ' -DLSB_FIRST=1 -DUSE_GLOBAL_STRUCT=0 -DCOGMTVM=0 -m32' 	
	! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 2/12/2011 21:55'!
compilerFlags
	"depends on config ..."
	^ self commonCompilerFlags, ' ' ,self compilerFlagsRelease! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/26/2011 20:45'!
compilerFlagsDebug

	^ '-g3 -O0 -msse2 -D_GNU_SOURCE -DITIMER_HEARTBEAT=1 -DNO_VM_PROFILE=1 -DDEBUGVM=1'

! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/26/2011 20:47'!
compilerFlagsRelease

	^ '-g0 -O2 -msse2 -D_GNU_SOURCE -DNDEBUG -DITIMER_HEARTBEAT=1 
	-DNO_VM_PROFILE=1 -DDEBUGVM=0'

! !

!CogUnixConfig methodsFor: 'headers generation' stamp: 'IgorStasenko 3/15/2011 17:54'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif


/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!CogUnixConfig methodsFor: 'sources' stamp: 'Igor.Stasenko 1/7/2011 17:10'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CogUnixConfig methodsFor: 'plugins' stamp: 'IgorStasenko 8/8/2011 15:32'!
defaultExternalPlugins
	^ #(
		B3DAcceleratorPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		"UUIDPlugin"
		"UnixOSProcessPlugin ?? "	
	)! !

!CogUnixConfig methodsFor: 'plugins' stamp: 'IgorStasenko 7/7/2011 17:04'!
defaultInternalPlugins
" took from unixbuild/bld/plugins.int"
	^ #(
		ADPCMCodecPlugin 
		AsynchFilePlugin 
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin 
		CroquetPlugin 
		DeflatePlugin  "ZipPlugin"
		DropPlugin 
		DSAPlugin "DSAPrims" 
		FFTPlugin 
		FileCopyPlugin 
		FilePlugin 
		FloatArrayPlugin 
		FloatMathPlugin 
		IA32ABIPlugin "IA32ABI"
		JoystickTabletPlugin 
		JPEGReaderPlugin 
		JPEGReadWriter2Plugin 
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		Matrix2x3Plugin 
		MIDIPlugin 
		MiscPrimitivePlugin 
		Mpeg3Plugin 
		RePlugin 	
		SecurityPlugin 
		SerialPlugin 
		SocketPlugin 
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin	
		LocalePlugin
		)! !

!CogUnixConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CogUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/6/2011 16:15'!
extraPluginSettings: maker
	super extraPluginSettings: maker.  
	maker set: #linkFlags toString: '${linkFlags} -m32'
! !

!CogUnixConfig methodsFor: 'sources' stamp: 'Igor.Stasenko 1/18/2011 10:45'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'version.c'! !

!CogUnixConfig methodsFor: 'headers generation' stamp: 'Igor.Stasenko 1/15/2011 14:55'!
generateConfigH
	"will fix that later"
	self write: self configH toFile: 'config.h'! !

!CogUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:37'!
interpreterClass
	^ CoInterpreter! !

!CogUnixConfig methodsFor: 'accessing' stamp: 'NicolasPasserini 3/30/2011 16:48'!
linkFlags 
	^ super linkFlags , ' -m32'! !

!CogUnixConfig methodsFor: 'sources' stamp: 'Igor.Stasenko 1/16/2011 00:53'!
platformSources
	"files added from platform/unix/vm dir "
	^ #(
	'aio.c'
	'debug.c'
"	'dlfcn-dyld.c'
	'mac-alias.c' "
	'osExports.c'
	'sqUnixCharConv.c'
"	'sqUnixEvent.c' "
	'sqUnixExternalPrims.c'
	'sqUnixHeartbeat.c'
	'sqUnixMain.c'
	'sqUnixMemory.c'
	'sqUnixThreads.c'
	'sqUnixVMProfile.c'
	)! !

!CogUnixConfig methodsFor: 'source files' stamp: 'IgorStasenko 2/9/2011 20:21'!
preferredIncludes
	^ #( '${targetPlatform}/plugins/B3DAcceleratorPlugin')
	! !

!CogUnixConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:50'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!CogUnixConfig methodsFor: 'utils' stamp: 'NicolasPasserini 3/30/2011 16:40'!
setExtraTargetProperties: maker

	maker setTargetProperties: 'LINK_FLAGS "-m32"'.
		
	maker puts: 'set_source_files_properties( ${srcVMDir}/cogit.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -momit-leaf-frame-pointer -mno-rtd -mno-accumulate-outgoing-args")'.
		
	
	maker 
		cmd: 'set_source_files_properties'
		params: ' ${targetPlatform}/vm/sqUnixHeartbeat.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -mno-rtd -mno-accumulate-outgoing-args"'.
						
	super setExtraTargetProperties: maker.
! !

CogUnixConfig subclass: #CogUnixDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogUnixDebugConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
THis is a concrete class which generates a DEBUG CogVM for Unix systems. This VM is normally known as a debug CogVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.


Fore more information, check the class comments of all the superclasses.
!

!CogUnixDebugConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/12/2011 21:56'!
compilerFlags

	^  self commonCompilerFlags, ' ' ,self compilerFlagsDebug! !

CogUnixConfig subclass: #CogUnixNoGLConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogUnixNoGLConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
A slightly modified configuration, which avoids linking with openGL libraries.


Fore more information, check the class comments of all the superclasses.
!

!CogUnixNoGLConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/4/2011 12:41'!
addDriver: name sources: aSources generator: cmakeGen

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS "-lSM -lICE -ldl -lpthread -lm -lnsl -lX11"'
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!CogUnixNoGLConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/4/2011 12:39'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1

#undef	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#undef	HAVE_GL_GL_H 1
#undef	HAVE_OPENGL_GL_H 

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

CogUnixConfig subclass: #StackUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!StackUnixConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
This is a concrete class which generates a StackVM for Unix.

Usage: 
StackInterpreterUnixConfig generateWithSources


Fore more information, check the class comments of all the superclasses.
!

!StackUnixConfig methodsFor: 'sources' stamp: 'IgorStasenko 2/10/2011 11:24'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackUnixConfig methodsFor: 'accessing' stamp: 'IgorStasenko 7/7/2011 13:12'!
executableName
	^ 'StackVM'! !

!StackUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:35'!
interpreterClass
	^ StackInterpreter! !

!StackUnixConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

StackUnixConfig subclass: #StackUnixDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!StackUnixDebugConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
This is a concrete class which generates a DEBUG StackVM for Unix systems. This VM is normally known as a debug StackVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.


Fore more information, check the class comments of all the superclasses.
!

!StackUnixDebugConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 2/12/2011 21:56'!
compilerFlags

	^  self commonCompilerFlags, ' ' ,self compilerFlagsDebug! !

StackUnixDebugConfig subclass: #StackUnixDebugFixedVerSIConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!StackUnixDebugFixedVerSIConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
This is done specifically to track down the instability issues of Cog VM on UNIX


Fore more information, check the class comments of all the superclasses.
!

!StackUnixDebugFixedVerSIConfig methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/26/2011 20:46'!
compilerFlagsDebug

	^ '-g3 -O0 -msse2 -save-temps -D_GNU_SOURCE -DITIMER_HEARTBEAT=1 -DNO_VM_PROFILE=1 -DCOGMTVM=0 -DDEBUGVM=1'

! !

!StackUnixDebugFixedVerSIConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/10/2011 19:43'!
extraVMSettings: maker
	| versionC |
	self generateConfigH.
	
	
	"output a fake version.c file"
	
	self write:
'int vm_serial= 1;
char *vm_date= "<HERE IS SUPPOSED TO BE THE DATE>";
char *cc_version= "<HERE IS SUPPOSED TO BE gcc VERSION>";
char *ux_version= "<FAKE FROZEN VERSION FOR DEBUGGING PURPOSES>";
'
	toFile: 'version.c'.
! !

CPlatformConfig subclass: #CogFamilyWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!CogFamilyWindowsConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:33' prior: 0!
This is an abstract class and it is the root configuration for building all types of Cog VMs on MS-Windows platform.


What you need to get started:

Download and install Msys, with C/C++ compiler support:
	http://www.mingw.org/wiki/msys
	
Download and install Git:
	http://code.google.com/p/msysgit/
	

///
Optional: add git to the PATH variable:

Add path to git for msys:
Control panel -> System -> System Properies / Advanced  [ Environment Variables ]

There should be already:
C:\Program Files\Git\cmd

add:

C:\Program Files\Git\bin

/// For automated builds, add SQUEAKVM environment variable and set it to the full path to squeak executable.

(Control panel -> System -> System Properies / Advanced  [ Environment Variables ])

in windows shell you can use it then to run squeak: %SQUEAKVM%  , and in mingw bash shell, use $SQUEAKVM

/// Install CMake:
http://www.cmake.org/cmake/resources/software.html

(during installation, in install options , make sure that you choose to add CMake to PATH)


Note, to run cmake under msys shell, you have to explicitly specify the msys makefiles generator, because default one is MS:

cmake . -G"MSYS Makefiles"


Fore more information, check the class comments of all the superclasses.
!

!CogFamilyWindowsConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 8/10/2011 01:54'!
commonCompilerFlags
	"omit -ggdb2 to prevent generating debug info"
	
	^ '-march=pentium4 -mwindows -D_MT -msse2 -mthreads -mno-cygwin -mwin32 -mno-rtd -mms-bitfields -mno-accumulate-outgoing-args ', self winVer ,

	' -DWIN32 -DWIN32_FILE_SUPPORT -DNO_ISNAN -DNO_SERVICE -DNO_STD_FILE_SUPPORT ',
	'-DLSB_FIRST -DVM_NAME="', self executableName,'" -DX86 '! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:07'!
configureAsynchFilePlugin:  maker 
	"extra rules for AsynchFilePlugin "

	super configureAsynchFilePlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32AsyncFilePrims.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:20'!
configureB3DAcceleratorPlugin:  maker 
	"extra rules for B3DAcceleratorPlugin "

	super configureB3DAcceleratorPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32DualB3DX.c' 'sqWin32D3D.c' 'sqWin32OpenGL.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:23'!
configureCroquetPlugin:  maker 
	"extra rules for CroquetPlugin "

	super configureCroquetPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32CroquetPlugin.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:06'!
configureDropPlugin:  maker 
	"extra rules for DropPlugin "

	super configureDropPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32Drop')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/7/2011 16:23'!
configureFT2Plugin: maker 
	"extra rules for FT2Plugin"
	

	"extra rules for Freetype plugin.
	a custom rule to build freetype library"

	maker set: #freetypeLibDir toString: '${buildDir}/FT2Plugin'.
	maker set: #freetypeLib toString: '${freetypeLibDir}/libfreetype.dll.a'.


	maker cmd: 'add_custom_command' params: 'OUTPUT ${freetypeLib} 
		COMMAND "${pluginPlatform}/makeFreetype.dynamic.win32" "${freetypeLibDir}" "${outputDir}"
		COMMENT "Building freetype library"
	'.

	maker addSource: '${freetypeLib}'.
	maker addExternalLibrary:  '"${freetypeLib}"'.

	"the freetype sources are located in {build}/FT2Plugin/freetype2/include "
	maker includeDirectories: '${freetypeLibDir}/freetype2/include'

! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 01:53'!
configureFilePlugin: maker 
	
	super configureFilePlugin: maker.
	
	maker addPlatformSources:
		#( 'sqWin32FilePrims.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:12'!
configureHostWindowPlugin:    maker 
	"extra rules for HostWindowPlugin "

	super configureHostWindowPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32HostWindowPlugin.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:03'!
configureJoystickTabletPlugin:  maker 
	
	super configureJoystickTabletPlugin:  maker.
	
	maker addPlatformSources:
		#( 'sqWin32Joystick.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:10'!
configureLocalePlugin:   maker 
	"extra rules for LocalePlugin "

	super configureLocalePlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32Locale.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:09'!
configureMIDIPlugin:  maker 
	"extra rules for MIDIPlugin "

	super configureMIDIPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32MIDI.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:24'!
configureMpeg3Plugin:  maker 
	"extra rules for Mpeg3Plugin "

	super configureMpeg3Plugin:  maker.
	
	maker addDefinitions: '-DNOPTHREADS'.

	maker addPlatformSources: #( 'sqOpenFile.c')! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:05'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"

	super configureSecurityPlugin: maker.
	
	maker addPlatformSources: #( 'sqWin32Security')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:13'!
configureSerialPlugin:     maker 
	"extra rules for SerialPlugin "

	super configureSerialPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32SerialPort.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:08'!
configureSocketPlugin:  maker 
	"extra rules for SocketPlugin "

	super configureSocketPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32NewNet.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 01:49'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"
	
	maker addPlatformSources:
		#( 'sqWin32UUID.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/7/2011 06:45'!
configureWin32OSProcessPlugin: maker 
	"extra rules for Win32OSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker includeDirectories: '${crossDir}/plugins/SocketPlugin'.
! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 19:26'!
executableType
	^ 'WIN32'! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 19:29'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String crlf! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 19:55'!
msysPathFor: aPath
	| path |
	
	path := aPath.
	
	path := path copyReplaceAll: '\' with: '/'.
	
	^ path " copyReplaceAll: '\' with: '\\'"! !

!CogFamilyWindowsConfig methodsFor: 'directories' stamp: 'IgorStasenko 7/6/2011 21:08'!
outputDir

	"the directory where built binaries will be stored"

	^ outputDir ifNil: [ outputDir := self msysPathFor: (self buildDir containingDirectory fullName , '/', self outputDirName) ]
	! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 16:51'!
platformName
	^ 'win32'! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 7/6/2011 21:06'!
setupDirectories: gen
	"we have to override that, because we need to convert windoze paths to msys ones"
	
	| dirsInclude |
	

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self msysPathFor: self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil:[ self msysPathFor: self buildDir fullName ]);
			set: #platformsDir toString: (self msysPathFor: self platformsDir);
			set: #srcDir toString: (self msysPathFor: self srcDir);
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: (self msysPathFor: self outputDir).
	].

	self write: dirsInclude toFile: 'directories.cmake'! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 18:15'!
winVer
	"Set minimum version to WindowsXP (see /cygwin/usr/include//w32api/w32api.h)"
	
	^ '-D_WIN32_WINNT=0x0501 -DWINVER=0x0501'! !

CogFamilyWindowsConfig subclass: #CogWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!CogWindowsConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:33' prior: 0!
This is a concrete configuration for building a CogVM on Win32 platform.

Built artifacts are placed in ${build}/results dir.
Note, that executable contains debug info. Stript it (using strip command) before packaging for distribution.


Fore more information, check the class comments of all the superclasses.
!

CogWindowsConfig subclass: #CogMTWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!CogMTWindowsConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:33' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Win32. This VM is normally known as CogMTVM.


Fore more information, check the class comments of all the superclasses.
!

!CogMTWindowsConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/17/2011 23:35'!
compilerFlags
	^ super compilerFlags, ' -DCOGMTVM=1'! !

!CogMTWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 23:33'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!CogMTWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/17/2011 23:38'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!CogMTWindowsConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/17/2011 23:38'!
defaultExternalPlugins

	^ #(
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
	
		"Win32OSProcessPlugin"
	)! !

!CogMTWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:25'!
executableName
	^ 'CogMTVM'! !

!CogMTWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:37'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ CoInterpreterMT! !

!CogWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:30'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CogWindowsConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/16/2011 18:06'!
compilerFlags
	"depends on config ..."
	^ self commonCompilerFlags, ' ' ,self compilerFlagsRelease! !

!CogWindowsConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 8/10/2011 02:05'!
compilerFlagsRelease
	"Define NDEBUG for production to exclude asserts "
	^ '-g0 -O2 -march=pentium4 -momit-leaf-frame-pointer -maccumulate-outgoing-args -funroll-loops ',
	'-DNDEBUG -DDEBUGVM=0'! !

!CogWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/16/2011 16:53'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CogWindowsConfig methodsFor: 'plugins' stamp: 'IgorStasenko 8/8/2011 15:32'!
defaultExternalPlugins

	^ #(
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
	
		"Win32OSProcessPlugin"
	)! !

!CogWindowsConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/16/2011 18:40'!
defaultInternalPlugins

	^ #(
	
ADPCMCodecPlugin 
AsynchFilePlugin
B3DAcceleratorPlugin 
BalloonEnginePlugin "B2DPlugin" 
BitBltSimulation "BitBltPlugin"
BMPReadWriterPlugin 
CroquetPlugin 
DeflatePlugin  "ZipPlugin"
DropPlugin 
DSAPlugin "DSAPrims" 
FFTPlugin 
FilePlugin 
FloatArrayPlugin 
FloatMathPlugin 
HostWindowPlugin 
IA32ABIPlugin "IA32ABI"
JoystickTabletPlugin 
JPEGReaderPlugin 
JPEGReadWriter2Plugin 
KlattSynthesizerPlugin "Klatt"
LargeIntegersPlugin "LargeIntegers"
LocalePlugin 
Matrix2x3Plugin 
MIDIPlugin 
MiscPrimitivePlugin 
Mpeg3Plugin 
RePlugin 
SecurityPlugin 
SerialPlugin 
SocketPlugin 
SoundCodecPlugin "SoundCodecPrims"
SoundGenerationPlugin 
StarSqueakPlugin 
SurfacePlugin 
UUIDPlugin

	)! !

!CogWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CogWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/17/2011 02:02'!
externalLibraries
	
	^ #( 
		ddraw dinput opengl32 wsock32 comdlg32 ole32 winmm
		version wininet user32 gdi32 psapi kernel32 crtdll dsound secur32
	).! !

!CogWindowsConfig methodsFor: 'plugins' stamp: 'IgorStasenko 7/6/2011 21:09'!
extraPluginSettings: maker


	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: '${outputDir}'.
		
		maker cmd: 'set_target_properties' params:  maker moduleName , ' PROPERTIES PREFIX "" '
	]! !

!CogWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/25/2011 22:08'!
extraSources

	^ 
	'${resources}'! !

!CogWindowsConfig methodsFor: 'settings' stamp: 'IgorStasenko 3/25/2011 22:24'!
extraVMSettings: maker

	| res |
	
	res := '"${buildDir}/resource.o"'.
	
	self write: self resourceFile toFile: 'Cog.rc'.
		
	maker cmd: 'add_custom_command' params: 'OUTPUT ', res ,
	'
		COMMAND 	windres --include-dir ${targetPlatform}/misc -D_WIN32 -i ${buildDir}/Cog.rc -o ', res , '
		COMMENT "Generating resource file..."
	'.
	
	maker set:  #resources to: res.
	
	maker includeDirectories: '${targetPlatform}/third-party/dx9sdk/Include'.
	! !

!CogWindowsConfig methodsFor: 'resources' stamp: 'IgorStasenko 3/25/2011 22:23'!
iconFileName
	^ 'Cog.ico'! !

!CogWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:27'!
interpreterClass
	^ CoInterpreter! !

!CogWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/16/2011 16:58'!
platformSources
	"files added from platform/win32/vm dir "
	^ #(
		'sqWin32Alloc.c'
		'sqWin32Directory.c'
		'sqWin32Heartbeat.c'
		'sqWin32Service.c'
		'sqWin32VMProfile.c'
		'sqWin32Args.c'
		'sqWin32Exports.c'
		'sqWin32Intel.c'
		'sqWin32Stubs.c'
		'sqWin32Window.c'
		'sqWin32Backtrace.c'
		'sqWin32ExternalPrims.c'
		'sqWin32PluginSupport.c'
		'sqWin32Threads.c'
		'version.c'
		'sqWin32DirectInput.c'
		'sqWin32GUID.c'
		'sqWin32Prefs.c'
		'sqWin32Utils.c'
	)! !

!CogWindowsConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:50'!
prepareForGeneration
	^ self prepareForCogGeneration! !

!CogWindowsConfig methodsFor: 'resources' stamp: 'IgorStasenko 3/25/2011 22:22'!
resourceFile

	^ self resourceFileTemplate
		copyReplaceAll: '@ICON@' with: self iconFileName! !

!CogWindowsConfig methodsFor: 'resources' stamp: 'IgorStasenko 3/25/2011 22:22'!
resourceFileTemplate

	^ '
#ifdef _WIN32
1                       ICON    DISCARDABLE     "@ICON@"
2                       ICON    DISCARDABLE     "@ICON@"
3                       ICON    DISCARDABLE     "@ICON@"
#endif
'! !

!CogWindowsConfig methodsFor: 'utils' stamp: 'IgorStasenko 7/6/2011 21:09'!
setExtraTargetProperties: maker

	maker addExternalLibraries: self externalLibraries.
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: '${outputDir}'.
! !

CogWindowsConfig subclass: #StackWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!StackWindowsConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:33' prior: 0!
This is a configuration for building StackVM on Win32 platform.


Fore more information, check the class comments of all the superclasses.
!

!StackWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/17/2011 02:51'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/17/2011 02:52'!
executableName
	^ 'StackVM'! !

!StackWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:36'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ StackInterpreter! !

!StackWindowsConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	^ self prepareForStackVMGeneration! !

CPlatformConfig subclass: #MacOSConfig
	instanceVariableNames: 'resourcesDir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!MacOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:33' prior: 0!
This is an abstract class for all Mac Carbon configurations. It is intended to share code between different concrete implementations. 

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).


Fore more information, check the class comments of all the superclasses.
!

MacOSConfig subclass: #CocoaIOSConfig
	instanceVariableNames: 'generateForRelease'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CocoaIOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is an abstract class for all Mac Cocoa configurations. It is intended to share code between different concrete implementations. 

Fore more information, check the class comments of all the superclasses.
!

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:10'!
CFBundleExecutable
	^ self executableName ! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:10'!
CFBundleGetInfoString
	^ self CFBundleShortVersionString
! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/3/2011 20:17'!
CFBundleIconFile
	"An application icon"
	^ 'Squeak.icns'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:12'!
CFBundleIdentifier
	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	^ 'org.squeakfoundation.Squeak'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:10'!
CFBundleName
	"An application name"
	^ self executableName, ' (Cocoa) 32bits'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:11'!
CFBundleShortVersionString
	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 7/8/2011 13:41'!
CFBundleVersion
	"An application version"
	^ '6.0'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/10/2011 22:08'!
NSMainNibFile
	^'MainMenu'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 11/29/2011 16:18'!
SqueakDebug
	^self isGenerateForRelease 
		ifTrue: [ 0 ]
		ifFalse: [ 1 ]! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/28/2011 19:54'!
architecture 
	^'i386'! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 7/20/2011 09:49'!
commonCompilerFlags
	"Common compiler flags"
	^#('-arch i386' "'-fnext-runtime'" '-mmacosx-version-min=10.4' '-DHAVE_UUID_GENERATE')! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/29/2011 16:18'!
compilerFlags 
	| releaseFlags |
	
	releaseFlags := self isGenerateForRelease 
		ifTrue: [ self compilerFlagsRelease ]
		ifFalse: [ self compilerFlagsDebug ].
		
	^String streamContents: [ :stream |
		(self commonCompilerFlags, releaseFlags)
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream space ] ]! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/11/2011 09:36'!
compilerFlagsRelease 
	^#(
	"'-fobjc-direct-dispatch'" 
	'-msse3'
	"'-msse4.1'"
	"'-msse4.2'"
	"'-mdynamic-no-pic'" 
	"'-fwritable-strings'" 
	'-Os' 
	'-fvisibility=hidden'
	'-funroll-loops' 
	"'-fno-asm'" 
	'-fasm-blocks' 
	'-finline-functions' 
	'-mfpmath=sse' 
	'-fomit-frame-pointer' 
	'-march=pentium-m' 
	'-mtune=prescott' 
	'-falign-functions=16'  
	'-fno-gcse' 
	'-fno-cse-follow-jumps' 
	'-std=gnu99' 
	'-DBUILD_FOR_OSX' 
	'-DUSE_INLINE_MEMORY_ACCESSORS' 
	'-DLSB_FIRST' 
	'-DUSE_INLINE_MEMORY_ACCESSORS' 
	'-DHAVE_SYS_TIME_H' 
	'-DHAVE_NANOSLEEP' 
	'-DICC_DEBUG=0'
	'-DICC_OPTLEVEL="speedHLO"' 
	'-DICC_OPT_IPO_FOR_SINGLE_FILE_COMPILATION=1' 
	'-DICC_OPT_PARALLEL=0' 
	'-DICC_OPT_PREFETCH_INSERTION=1' 
	'-DICC_OPT_PROVIDE_FRAME_PTR=0' 
	'-DICC_OPT_USE_ARCH_IA32="SSE42"')! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 7/22/2011 09:42'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker. 
	maker addFrameworks: self frameworks.	 
	maker addPlatformSources: #( 'sqMacOpenGL.c' 'sqMacOpenGLInfo.c')! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'MarianoMartinezPeck 4/23/2011 13:32'!
configureClipboardExtendedPlugin: maker
	
	maker addPlatformSources: #('sqMacExtendedClipboard.m' ) 
	! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/10/2011 19:49'!
configureHostWindowPlugin: maker
	super configureHostWindowPlugin: maker.
	maker 
		addSources: #('sqMacHostWindow.c' ) 
		prefixed: '${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin/'
! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/26/2011 11:34'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 
			'HID_Error_Handler.c'
			'HID_Name_Lookup.c'
			'HID_Queue_Utilities.c'
			'HID_Utilities.c'
			'sqMacJoystickAndTablet.c'
			)
! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 4/2/2011 10:10'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"

	super configureLocalePlugin: maker.  
	maker addPlatformSources: #( 'sqMacLocaleCarbon.c' )! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/17/2011 16:57'!
configureMacMenubarPlugin: maker
	maker includeDirectories: '${platformsDir}/iOS/plugins/MacMenubarPlugin'.
	maker 
		addSources: #('MacMenuOS9ToOSX.m') 
		prefixed: '${platformsDir}/iOS/plugins/MacMenubarPlugin/'
! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 7/20/2011 13:47'!
configureObjectiveCPlugin: maker 
	"extra rules for ObjectiveCPlugin"

	maker addDefinitions: ' -x objective-c'.
	maker addFrameworks: self frameworks.
	maker includeDirectories: '${platformsDir}/iOS/plugins/SqueakObjectiveC'.
	maker 
		addSources: #('squeakProxy.m' 'squeakSUnitTester.m') 
		prefixed: '${platformsDir}/iOS/plugins/SqueakObjectiveC/'.
	! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/10/2011 19:48'!
configureSoundPlugin: maker
	super configureSoundPlugin: maker.
	
	maker includeDirectories: '${platformsDir}/Cross/plugins/SoundPlugin ${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'.
	maker 
		addSources: #('sqSqueakSoundCoreAudio.m' 'sqSqueakSoundCoreAudioAPI.m' ) 
		prefixed: '${platformsDir}/iOS/plugins/SoundPlugin/'.
	maker 
		addSources: #('sqSqueakOSXSoundCoreAudio.m' ) 
		prefixed: '${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin/'! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 7/20/2011 14:31'!
configureUUIDPlugin: maker
	super configureUUIDPlugin: maker.
	maker addFrameworks: #(CoreFoundation).  
	maker addDefinitions: '-x objective-c'.  
	maker addPlatformSources: #('sqMacUUID.c' )! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 08:40'!
coreSources
	^#('interp.c')! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 20:25'!
crossSources 
	^#(
		'sqNamedPrims.c'
		'sqVirtualMachine.c')! !

!CocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 1/2/2011 09:29'!
defaultExternalPlugins
	^#()! !

!CocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 3/26/2011 15:42'!
defaultInternalPlugins
	^ #(
		ADPCMCodecPlugin
		BMPReadWriterPlugin 
		BalloonEnginePlugin 
		BitBltSimulation 
		ClipboardExtendedPlugin 
		DSAPlugin 
		DeflatePlugin 
		DropPlugin 
		FFIPlugin
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		GeniePlugin 
		HostWindowPlugin 
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin 
		KlattSynthesizerPlugin 
		LargeIntegersPlugin 
		MacMenubarPlugin 
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		RePlugin 
		SecurityPlugin 
		SocketPlugin 
		SoundCodecPlugin 
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin)! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/3/2011 14:37'!
executableType
	^ 'MACOSX_BUNDLE'! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 11/29/2011 15:43'!
extraPluginSettings: maker	
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.
	
	maker 
		setTargetProperty: 'COMPILE_FLAGS' 
		to: '"-include \"', (self buildDir / self prefixHeaderFileName) fullName, '\""'.  

	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir.
		maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
		maker puts: 'list(APPEND linkFlags "-undefined dynamic_lookup")' ].
	
	"maker addXCodeProperty: 'GCC_VERSION' value: '4.3'."
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/' , self executableName , '_Prefix.pch'.
	
! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 9/19/2011 12:23'!
extraSources
	^'${buildDir}/', self prefixHeaderFileName, '
 ${resources} ', 
	'${buildDir}/', self prefixHeaderFileName, '
 ${resourcesLocaleEnglish}'! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 12/3/2011 11:29'!
extraVMSettings: maker
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: self architecture.

	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.
	maker 
		set: 'resources' 
		to: (String streamContents: [ :stream | 
			self  resources
				do: [ :each | 
					stream 
						nextPut: $";
						nextPutAll: '${resourceDir}/';
						nextPutAll: each;
						nextPut: $"]
				separatedBy: [ stream space ] ]).
		
	maker set: 'resourcesLocaleEnglish' to: 
	     '"${resourceDir}/English.lproj/InfoPlist.strings"
		"${resourceDir}/English.lproj/MainMenu.nib"'
! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 7/29/2011 14:38'!
frameworks
	^ #(
	Cocoa
	Foundation
	AudioToolbox
	CoreAudio
	SystemConfiguration
	ApplicationServices
	QuartzCore
	OpenGL
	AGL)! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/29/2011 16:18'!
generateForDebug
	generateForRelease := false! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/29/2011 16:18'!
generateForRelease
	generateForRelease := true! !

!CocoaIOSConfig methodsFor: 'initialization' stamp: 'EstebanLorenzano 11/29/2011 16:18'!
initialize 
	super initialize.
	self generateForRelease! !

!CocoaIOSConfig methodsFor: 'testing' stamp: 'EstebanLorenzano 11/29/2011 16:18'!
isGenerateForRelease 
	^generateForRelease! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/3/2011 07:50'!
platformName 
	^'iOS'! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 20:25'!
platformSources
	"files added from platform/iOS/vm dir "
	^ #(
		'Common/main.m'
		'Common/aio.c'
		'Common/Classes/Queue.m'
		'Common/Classes/sqMacV2Time.c'
		'Common/Classes/sqSqueakAppDelegate.m'
		'Common/Classes/sqSqueakFileDirectoryAPI.m'
		'Common/Classes/sqSqueakFileDirectoryInterface.m'
		'Common/Classes/sqSqueakInfoPlistInterface.m'
		'Common/Classes/sqSqueakMainApp.m'
		'Common/Classes/sqSqueakMainApplication.m'
		'Common/Classes/sqSqueakMainApplication+attributes.m'
		'Common/Classes/sqSqueakAttributesAPI.m'
		'Common/Classes/sqSqueakMainApplication+events.m'
		'Common/Classes/sqSqueakEventsAPI.m'
		'Common/Classes/sqSqueakMainApplication+imageReadWrite.m'
		'Common/Classes/sqSqueakMainApplication+sound.m'
		'Common/Classes/sqSqueakSoundAPI.m'
		'Common/Classes/sqSqueakMainApplication+vmAndImagePath.m'
		'Common/Classes/sqSqueakVmAndImagePathAPI.m'
		'Common/Classes/sqSqueakMainApplication+screen.m'
		'Common/Classes/sqSqueakScreenAPI.m'
		'Common/Classes/sqSqueakScreenAndWindow.m'
		'Common/Classes/sqSqueakCursorAPI.m'
		'Common/Classes/sqSqueakMainApplication+cursor.m'
		'OSX/SqueakOSXAppDelegate.m'
		'OSX/sqMacV2Browser.m'
		'OSX/sqMacUnixExternalPrims.m'
		'OSX/sqSqueakOSXApplication.m'
		'OSX/sqSqueakOSXFileDirectoryInterface.m'
		'OSX/sqSqueakOSXApplication+attributes.m'
		'OSX/sqSqueakOSXInfoPlistInterface.m'
		'OSX/sqSqueakOSXApplication+imageReadWrite.m'
		'OSX/sqSqueakOSXScreenAndWindow.m'
		'OSX/sqSqueakOSXNSView.m'
		'OSX/SqViewClut.m'
		'OSX/BitMapConversionLogicFromX11.c'
		'OSX/SqViewBitmapConversion.m'
		'OSX/macintoshosxextra.c'
		'OSX/sqSqueakOSXApplication+cursor.m'
		'OSX/sqSqueakOSXApplication+events.m'
		'OSX/keyBoardStrokeDetails.m'
		'OSX/SqueakOSXApplication.m'
		'OSX/sqSqueakOSXClipboardAPI.m'
		'OSX/sqSqueakOSXApplication+clipboard.m'
		'OSX/sqSqueakOSXDropAPI.m'
		'iPhone/sqMacV2Memory.c'
		'iPhone/osExports.c')! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 10/3/2011 15:39'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier
	NSMainNibFile
	SqueakDebug) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key) asString
	].

	^ self fixLineEndsOf: plist! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 10/3/2011 15:37'!
plistTemplate 
^'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakImage.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakSources.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakChanges.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>FAST</string>
	<key>CFBundleVersion</key>
	<string>21.0</string>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>LSMinimumSystemVersion</key>
	<string>${MACOSX_DEPLOYMENT_TARGET}</string>
	<key>NSMainNibFile</key>
	<string>@NSMainNibFile@</string>
	<key>NSPrincipalClass</key>
	<string>SqueakOSXApplication</string>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>@SqueakDebug@</integer>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakQuitOnQuitAppleEvent</key>
	<false/>
	<key>SqueakResourceDirectory</key>
	<string></string>
	<key>SqueakTrustedDirectory</key>
	<string>/foobar/tooBar/forSqueak/bogus/</string>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Squeak/Internet/My Squeak/</string>
	<key>SqueakUseFileMappedMMAP</key>
	<false/>
	<key>SqueakUIFadeForFullScreenInSeconds</key>
	<real>0.5</real>
	<key>UTExportedTypeDeclarations</key>
	<array>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Image File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.image</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STim</string>
				<key>public.filename-extension</key>
				<array>
					<string>image</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-image</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.utf8-plain-text</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Sources File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.sources</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STso</string>
				<key>public.filename-extension</key>
				<array>
					<string>sources</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-sources</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.utf8-plain-text</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Changes File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.changes</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STch</string>
				<key>public.filename-extension</key>
				<array>
					<string>changes</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-changes</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Script File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.script</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>SOBJ</string>
				<key>public.filename-extension</key>
				<array>
					<string>sobj</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-script</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Project File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.project</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STpr</string>
				<key>public.filename-extension</key>
				<array>
					<string>pr</string>
				</array>
				<key>public.mime-type</key>
				<string>application/x-squeak-project</string>
			</dict>
		</dict>
	</array>
</dict>
</plist>
'! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/2/2011 12:08'!
pluginsDir 
	^'${srcDir}/vm/intplugins'! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/29/2011 10:29'!
precompiledHeaders 
	^
'//
// Prefix header for all source files of the ''', self executableName, ''' target in the ''', self executableName, ''' project
//

#ifdef __OBJC__
	', 
	(String streamContents: [ :stream | 
		self precompiledImports 
			do: [ :each | 
				stream 
					nextPutAll: '#import ';
					nextPut: $<;
					nextPutAll: each; 
					nextPut: $> ]
			separatedBy: [ 
				stream cr ] ]),  '
#endif
'! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/29/2011 10:25'!
precompiledImports 
	^#('Cocoa/Cocoa.h')! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 21:25'!
preferredIncludes
	^ #(
	'${buildDir}/'
	'${platformsDir}/iOS/vm/iPhone' "config.h is here. Why???"
	)
	! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/17/2011 18:40'!
prefixHeaderFileName 
	^self executableName, '_Prefix.pch'! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 12/3/2011 11:31'!
resources 
	^#('Squeak VM.r'
	'Cog.icns'
	'Squeak.icns'
	'SqueakChanges.icns'
	'SqueakPlugin.icns'
	'SqueakScript.icns'
	'SqueakGeneric.icns'
	'SqueakProject.icns'
	'SqueakSources.icns')

! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'MarianoMartinezPeck 4/26/2011 10:16'!
setExtraTargetProperties: maker
	| plist precompiledHeaders |

	" generated and add Info.plist file "
	plist := self plistFile.

	(maker buildDir forceNewFileNamed: 'Info.plist') 
		nextPutAll: plist; 
		close.

	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.  

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
			
	precompiledHeaders := (self executableName, '_Prefix.pch').
	(maker buildDir forceNewFileNamed: precompiledHeaders) 
		nextPutAll: self precompiledHeaders;
		close.
		
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/', precompiledHeaders.

	"maker 
		addXCodeProperty: 'GCC_ENABLE_SSE3_EXTENSIONS' value: 'YES';  
		addXCodeProperty: 'GCC_ENABLE_SSE41_EXTENSIONS' value: 'YES';
		addXCodeProperty: 'GCC_ENABLE_SSE42_EXTENSIONS' value: 'YES';
		addXCodeProperty: 'GCC_GENERATE_DEBUGGING_SYMBOLS' value: 'NO';  
		addXCodeProperty: 'GCC_INLINES_ARE_PRIVATE_EXTERN' value: 'YES';
		addXCodeProperty: 'GCC_UNROLL_LOOPS' value: 'YES'.	"
	
	"Extras"
	maker 
		addXCodeProperty: 'ICC_DEBUG' value: 'NO';
		addXCodeProperty: 'ICC_OPTLEVEL' value: 'speedHLO';
		addXCodeProperty: 'ICC_OPT_IPO_FOR_SINGLE_FILE_COMPILATION' value: 'YES';
		addXCodeProperty: 'ICC_OPT_PARALLEL' value: 'NO';
		addXCodeProperty: 'ICC_OPT_PREFETCH_INSERTION' value: 'YES';
		addXCodeProperty: 'ICC_OPT_PROVIDE_FRAME_PTR' value: 'NO';
		addXCodeProperty: 'ICC_OPT_USE_ARCH_IA32' value: 'SSE41';
		addXCodeProperty: 'PER_ARCH_CFLAGS_i386' value: '-finline-functions -mfpmath=sse -march=pentium-m -mtune=prescott -falign-functions=16  -fno-gcse -fno-cse-follow-jumps  -DLSB_FIRST -DUSE_INLINE_MEMORY_ACCESSORS';
		addXCodeProperty: 'PER_ARCH_CFLAGS_ppc' value: '-fast -mtune=7450 -mcpu=7450 -D_BSD_SOCKLEN_T_=int'! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/2/2011 10:15'!
srcDir 
	^'${topDir}/platforms/iOS/vm/src'! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 21:25'!
standardIncludes
	^ #(
	'${crossDir}/plugins/SerialPlugin'   
	'${targetPlatform}/plugins/FilePlugin'
	'${crossDir}/plugins/FilePlugin'
	'${targetPlatform}/plugins/HostWindowPlugin'
	'${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin' 
	'${crossDir}/plugins/HostWindowPlugin'
	'${crossDir}/plugins/DropPlugin'
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/SoundPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'
	'${platformsDir}/iOS/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/Common/Classes'
	'${platformsDir}/iOS/vm/OSX'
)
	! !

CocoaIOSConfig subclass: #CogFamilyCocoaIOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CogFamilyCocoaIOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is an abstract class for all Mac Cocoa Cog VMs family. That is, for all CogVMS (StackVM, CogVM, CogMTVM, etc). 

Fore more information, check the class comments of all the superclasses.
!

CogFamilyCocoaIOSConfig subclass: #CogCocoaIOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CogCocoaIOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is a concrete class which generates a CogVM for Mac using the Cocoa library

Fore more information, check the class comments of all the superclasses.
!

!CogCocoaIOSConfig methodsFor: 'source generation' stamp: 'MarianoMartinezPeck 4/23/2011 19:34'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CogCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 2/5/2011 10:02'!
compilerFlagsRelease 
	^super compilerFlagsRelease, #('-DCOGVM')! !

!CogCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/27/2011 18:13'!
coreSources 
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CogCocoaIOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CogCocoaIOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:47'!
interpreterClass
	^ CoInterpreter! !

!CogCocoaIOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/23/2011 15:17'!
pluginsDir 
	^'${srcDir}/plugins'! !

!CogCocoaIOSConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:50'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!CogCocoaIOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:51'!
srcDir 
	"Answer the value of srcDir"

	^ srcDir ifNil: [ srcDir := (self topDir / self srcDirName) fullName ]! !

!CogCocoaIOSConfig methodsFor: 'plugins' stamp: 'IgorStasenko 8/8/2011 15:32'!
versionExternalPlugins 
	^Array 
		with: #ThreadedIA32FFIPlugin
		with: #IA32ABIPlugin! !

CogCocoaIOSConfig subclass: #CogMTCocoaIOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CogMTCocoaIOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Mac using the Cocoa library. This VM is normally known as CogMTVM.

Fore more information, check the class comments of all the superclasses.
!

!CogMTCocoaIOSConfig methodsFor: 'settings' stamp: 'MarianoMartinezPeck 4/26/2011 20:45'!
compilerFlagsDebug 
	^#('-g3' '-O0' '-msse3' "'-fvisibility=hidden'" '-funroll-loops' '-fasm-blocks' '-finline-functions' '-mfpmath=sse' '-march=pentium-m' '-falign-functions=16' '-fno-gcse' '-fno-cse-follow-jumps' '-std=gnu99' '-DBUILD_FOR_OSX' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DLSB_FIRST' '-DHAVE_SYS_TIME_H' '-DHAVE_NANOSLEEP' '-DDEBUGVM=1' '-DCOGMTVM=1' '-DUSE_GLOBAL_STRUCT=0' '-DBASE_HEADER_SIZE=4' '-DCOGVM')! !

!CogMTCocoaIOSConfig methodsFor: 'settings' stamp: 'MarianoMartinezPeck 4/26/2011 20:47'!
compilerFlagsRelease 
	^#('-g0' '-Os' '-msse3' "'-fvisibility=hidden'" '-funroll-loops' '-fasm-blocks' '-finline-functions' '-mfpmath=sse' '-fomit-frame-pointer' '-march=pentium-m' '-mtune=prescott' '-falign-functions=16' '-fno-gcse' '-fno-cse-follow-jumps' '-std=gnu99' '-DBUILD_FOR_OSX' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DLSB_FIRST' '-DHAVE_SYS_TIME_H' '-DHAVE_NANOSLEEP' '-DNDEBUG' '-DDEBUGVM=0' '-DCOGMTVM=1' '-DUSE_GLOBAL_STRUCT=0' '-DBASE_HEADER_SIZE=4' '-DCOGVM')! !

!CogMTCocoaIOSConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/18/2011 16:26'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!CogMTCocoaIOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:24'!
executableName
	^ 'CogMTVM'! !

!CogMTCocoaIOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 16:24'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ CoInterpreterMT! !

!CogMTCocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 7/2/2011 13:31'!
versionExternalPlugins 
	^Array 
		with: #ThreadedIA32FFIPlugin! !

CogMTCocoaIOSConfig subclass: #CogMTCocoaIOSGCC42Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CogMTCocoaIOSGCC42Config methodsFor: 'as yet unclassified' stamp: 'LucFabresse 12/22/2011 12:02'!
printExtraHeader: maker
	
	maker set: 'CMAKE_C_COMPILER' to: 'gcc-4.2'.
	maker set: 'CMAKE_CXX_COMPILER' to: 'g++-4.2'.
	
	! !

!CogFamilyCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 3/18/2011 12:05'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!CogFamilyCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 4/2/2011 11:54'!
CFBundleVersion
	"An application version"
	^ '6.0-pre'! !

!CogFamilyCocoaIOSConfig methodsFor: 'settings' stamp: 'MarianoMartinezPeck 4/26/2011 20:45'!
compilerFlagsDebug
	^#('-g3' '-O0' '-fvisibility=hidden' '-funroll-loops' '-fasm-blocks' '-finline-functions' '-mfpmath=sse' '-march=pentium-m' '-mtune=prescott' '-falign-functions=16' '-fno-gcse' '-fno-cse-follow-jumps' '-std=gnu99' '-DBUILD_FOR_OSX' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DLSB_FIRST' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DHAVE_SYS_TIME_H' '-DHAVE_NANOSLEEP' '-DDEBUGVM=1' '-DCOGMTVM=0' '-DUSE_GLOBAL_STRUCT=0' '-DBASE_HEADER_SIZE=4')! !

!CogFamilyCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/29/2011 18:20'!
compilerFlagsRelease 
	^#('-g0' '-Os' '-fvisibility=hidden' '-funroll-loops' '-fasm-blocks' '-finline-functions' '-mfpmath=sse' '-fomit-frame-pointer' '-march=pentium-m' '-mtune=prescott' '-falign-functions=16' '-fno-gcse' '-fno-cse-follow-jumps' '-std=gnu99' '-DBUILD_FOR_OSX' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DLSB_FIRST' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DHAVE_SYS_TIME_H' '-DHAVE_NANOSLEEP' '-DNDEBUG' '-DDEBUGVM=0' '-DCOGMTVM=0' '-DUSE_GLOBAL_STRUCT=0' '-DBASE_HEADER_SIZE=4')! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/23/2011 12:23'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 2/5/2011 09:28'!
configureHostWindowPlugin: maker
	super configureHostWindowPlugin: maker.
	maker includeDirectories: '${platformsDir}/Cross/plugins/HostWindowPlugin'.! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 7/14/2011 11:01'!
configureQuicktimePlugin: maker
	"extra rules for QuicktimePlugin"
	
	maker includeDirectories: '${platformsDir}/Cross/plugins/QuicktimePlugin'.! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 6/14/2011 12:55'!
configureUnixOSProcessPlugin: maker
	super configureHostWindowPlugin: maker.
	maker includeDirectories: '${platformsDir}/Cross/plugins/SocketPlugin'.! !

!CogFamilyCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 2/5/2011 09:15'!
crossSources 
	^super crossSources, #(
	'sqExternalSemaphores.c'
	'sqHeapMap.c'
	'sqTicker.c')! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 10/17/2011 10:17'!
defaultExternalPlugins 
	^(self versionExternalPlugins),
		#(
		UUIDPlugin
		FloatMathPlugin
		AsynchFilePlugin
		SerialPlugin
		Mpeg3Plugin
		CroquetPlugin
		JoystickTabletPlugin
		MIDIPlugin
		B3DAcceleratorPlugin
		LocalePlugin
		ObjectiveCPlugin
		QuicktimePlugin
		TestOSAPlugin
		"UnixOSProcessPlugin"
	)! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 10/17/2011 10:16'!
defaultInternalPlugins
	^ #(
		ADPCMCodecPlugin
		BMPReadWriterPlugin 
		BalloonEnginePlugin 
		BitBltSimulation 
		ClipboardExtendedPlugin
		DSAPlugin 
		DeflatePlugin 
		DropPlugin 
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		GeniePlugin 
		HostWindowPlugin 
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin 
		KlattSynthesizerPlugin 
		LargeIntegersPlugin 
		"MacMenubarPlugin" "This plugin is not yet ported"
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		RePlugin 
		SecurityPlugin 
		SocketPlugin 
		SoundCodecPlugin 
		SoundGenerationPlugin 
		SoundPlugin
		StarSqueakPlugin 
		SurfacePlugin 
		UnixOSProcessPlugin
		)! !

!CogFamilyCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 3/17/2011 17:20'!
extraSources
	" mac VM using some unix sources "
	
	^super extraSources,'
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/vm/sqUnixHeartbeat.c 
	${platformsDir}/unix/vm/sqUnixVMProfile.c 
	${platformsDir}/unix/vm/sqUnixThreads.c '! !

!CogFamilyCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 2/5/2011 09:15'!
platformSources
	"files added from platform/iOS/vm dir "
	^ #(
		'Common/main.m'
		"'Common/aio.c'"
		'Common/Classes/Queue.m'
		'Common/Classes/sqMacV2Time.c'
		'Common/Classes/sqSqueakAppDelegate.m'
		'Common/Classes/sqSqueakFileDirectoryAPI.m'
		'Common/Classes/sqSqueakFileDirectoryInterface.m'
		'Common/Classes/sqSqueakInfoPlistInterface.m'
		'Common/Classes/sqSqueakMainApp.m'
		'Common/Classes/sqSqueakMainApplication.m'
		'Common/Classes/sqSqueakMainApplication+attributes.m'
		'Common/Classes/sqSqueakAttributesAPI.m'
		'Common/Classes/sqSqueakMainApplication+events.m'
		'Common/Classes/sqSqueakEventsAPI.m'
		'Common/Classes/sqSqueakMainApplication+imageReadWrite.m'
		'Common/Classes/sqSqueakMainApplication+sound.m'
		'Common/Classes/sqSqueakSoundAPI.m'
		'Common/Classes/sqSqueakMainApplication+vmAndImagePath.m'
		'Common/Classes/sqSqueakVmAndImagePathAPI.m'
		'Common/Classes/sqSqueakMainApplication+screen.m'
		'Common/Classes/sqSqueakScreenAPI.m'
		'Common/Classes/sqSqueakScreenAndWindow.m'
		'Common/Classes/sqSqueakCursorAPI.m'
		'Common/Classes/sqSqueakMainApplication+cursor.m'
		'OSX/SqueakOSXAppDelegate.m'
		'OSX/sqMacV2Browser.m'
		'OSX/sqMacUnixExternalPrims.m'
		'OSX/sqSqueakOSXApplication.m'
		'OSX/sqSqueakOSXFileDirectoryInterface.m'
		'OSX/sqSqueakOSXApplication+attributes.m'
		'OSX/sqSqueakOSXInfoPlistInterface.m'
		'OSX/sqSqueakOSXApplication+imageReadWrite.m'
		'OSX/sqSqueakOSXScreenAndWindow.m'
		'OSX/sqSqueakOSXNSView.m'
		'OSX/SqViewClut.m'
		'OSX/BitMapConversionLogicFromX11.c'
		'OSX/SqViewBitmapConversion.m'
		'OSX/macintoshosxextra.c'
		'OSX/sqSqueakOSXApplication+cursor.m'
		'OSX/sqSqueakOSXApplication+events.m'
		'OSX/keyBoardStrokeDetails.m'
		'OSX/SqueakOSXApplication.m'
		'OSX/sqSqueakOSXClipboardAPI.m'
		'OSX/sqSqueakOSXApplication+clipboard.m'
		'OSX/sqSqueakOSXDropAPI.m'
		'iPhone/sqMacV2Memory.c'
		'iPhone/osExports.c'
	  	'Common/Classes/sqSqueakScreenAPI.m')! !

!CogFamilyCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/29/2011 15:44'!
setExtraTargetProperties: maker
	| plist |

	maker addFrameworks: self frameworks.

	" generated and add Info.plist file "
	plist := self plistFile.

	(maker buildDir forceNewFileNamed: 'Info.plist') 
		nextPutAll: plist; 
		close.

	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.  

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resourcesLocaleEnglish} PROPERTIES MACOSX_PACKAGE_LOCATION Resources/English.lproj'.


	maker 
		cmd: 'set_source_files_properties' 
		params: '${ENGLISH_RESOURCES} PROPERTIES MACOSX_PACKAGE_LOCATION Resources/English.lproj'.
			
	(maker buildDir forceNewFileNamed: self prefixHeaderFileName) 
		nextPutAll: self precompiledHeaders;
		close.
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/', self prefixHeaderFileName.

	maker 
		addXCodeProperty: 'PER_ARCH_CFLAGS_i386' value: '-DLSB_FIRST -mfpmath=sse -finline-functions  -fno-cse-follow-jumps -fno-gcse -mtune=prescott -march=pentium-m -falign-functions=16'.
		
	"maker 
		addXCodeProperty: 'GCC_VERSION' value: '4.3'."

	maker 
		cmd: 'set_target_properties' 
		params: self executableName, ' PROPERTIES COMPILE_FLAGS "-include \"', (self buildDir / self prefixHeaderFileName) fullName, '\""'. 
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
	maker set: 'RUNTIME_OUTPUT_DIRECTORY' toString: self outputDir.! !

!CogFamilyCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 3/22/2011 17:31'!
standardIncludes
	^#(
	'${srcDir}/vm'
	'${platformsDir}/iOS/vm/OSX'
	'${platformsDir}/unix/vm'
	'${platformsDir}/iOS/vm/Common/Classes'
	'${platformsDir}/iOS/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'
	'${crossDir}/plugins/SoundPlugin'
	'${crossDir}/plugins/HostWindowPlugin'
	'${platformsDir}/Cross/plugins/HostWindowPlugin'
	'${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin' "Sources are here :("
	'${crossDir}/plugins/FilePlugin'
	)	
! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 7/2/2011 13:32'!
versionExternalPlugins 
	"Cog Version Specific Plugins. Some times you can't use same plugins in a version (for instance, CogMT uses a diferent FFI, and you can't build IA32ABIPlugin in MT for now)"
	^Array 
		with: #FFIPlugin
		with: #IA32ABIPlugin! !

CogFamilyCocoaIOSConfig subclass: #StackCocoaIOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!StackCocoaIOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is a concrete class which generates a StackVM for Mac using the Cocoa library

Fore more information, check the class comments of all the superclasses.
!

StackCocoaIOSConfig subclass: #StackCocoaIOSCLANGConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!StackCocoaIOSCLANGConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
Experimental configuration for compiling using clang compiler

Fore more information, check the class comments of all the superclasses.
!

StackCocoaIOSCLANGConfig subclass: #StackCocoaIOSARMConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!StackCocoaIOSARMConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/28/2011 19:54'!
architecture 
	^'"armv6" "armv7"'! !

!StackCocoaIOSARMConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/28/2011 19:33'!
commonCompilerFlags
	"Common compiler flags"
	^#('-arch armv6' 
	'-arch armv7' 
	'-miphoneos-version-min=4.3' 
	'-isysroot /Developer/Platforms/iPhoneOS.platform/Developer/SDKs/iPhoneOS4.3.sdk' 
	'-x objective-c'
	'-DTARGET_OS_IS_IPHONE'
	'-DHAVE_UUID_GENERATE')! !

!StackCocoaIOSARMConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/18/2011 18:49'!
compilerFlagsDebug
	^#('-g3' '-O0' '-fvisibility=hidden' '-funroll-loops' '-fasm-blocks' '-finline-functions' '-mfpmath=sse' '-march=pentium-m' '-mtune=prescott' '-falign-functions=16' '-fno-gcse' '-fno-cse-follow-jumps' '-std=gnu99'  '-DUSE_INLINE_MEMORY_ACCESSORS' '-DLSB_FIRST' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DHAVE_SYS_TIME_H' '-DHAVE_NANOSLEEP' '-DDEBUGVM=1' '-DCOGMTVM=0' '-DUSE_GLOBAL_STRUCT=0' '-DBASE_HEADER_SIZE=4')! !

!StackCocoaIOSARMConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/18/2011 18:49'!
compilerFlagsRelease 
	^#('-g0' '-Os' '-fvisibility=hidden' '-funroll-loops' '-fasm-blocks' '-finline-functions' '-mfpmath=sse' '-fomit-frame-pointer' '-march=pentium-m' '-mtune=prescott' '-falign-functions=16' '-fno-gcse' '-fno-cse-follow-jumps' '-std=gnu99' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DLSB_FIRST' '-DUSE_INLINE_MEMORY_ACCESSORS' '-DHAVE_SYS_TIME_H' '-DHAVE_NANOSLEEP' '-DNDEBUG' '-DDEBUGVM=0' '-DCOGMTVM=0' '-DUSE_GLOBAL_STRUCT=0' '-DBASE_HEADER_SIZE=4')! !

!StackCocoaIOSARMConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/18/2011 15:07'!
defaultExternalPlugins 
	^#()! !

!StackCocoaIOSARMConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/18/2011 19:42'!
defaultInternalPlugins
	^#()
	"^ #(
		ADPCMCodecPlugin
		BMPReadWriterPlugin 
		BalloonEnginePlugin 
		BitBltSimulation 
		ClipboardExtendedPlugin
		DSAPlugin 
		DeflatePlugin 
		DropPlugin 
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		GeniePlugin 
		HostWindowPlugin 
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin 
		LargeIntegersPlugin 
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		RePlugin 
		SecurityPlugin 
		SocketPlugin 
		SoundCodecPlugin 
		SoundGenerationPlugin 
		SoundPlugin
		SurfacePlugin
		UUIDPlugin
		IOSPlugin
		)"! !

!StackCocoaIOSARMConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/18/2011 19:40'!
executableName
	^ 'iStackVM'! !

!StackCocoaIOSARMConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/28/2011 20:40'!
frameworks
	^ #(
	"AppKit"
	"Cocoa"
	AudioToolbox
	CoreAudio
	CoreGraphics
	CoreLocation
	UIKit
	Foundation
	SystemConfiguration
	"ApplicationServices"
	QuartzCore
	OpenGLES)! !

!StackCocoaIOSARMConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 11/18/2011 18:45'!
platformSources
	"files added from platform/iOS/vm dir "
	^ #(
		'Common/main.m'
		'Common/Classes/Queue.m'
		'Common/Classes/sqMacV2Time.c'
		'Common/Classes/sqSqueakAppDelegate.m'
		'Common/Classes/sqSqueakFileDirectoryAPI.m'
		'Common/Classes/sqSqueakFileDirectoryInterface.m'
		'Common/Classes/sqSqueakInfoPlistInterface.m'
		'Common/Classes/sqSqueakMainApp.m'
		'Common/Classes/sqSqueakMainApplication.m'
		'Common/Classes/sqSqueakMainApplication+attributes.m'
		'Common/Classes/sqSqueakAttributesAPI.m'
		'Common/Classes/sqSqueakMainApplication+events.m'
		'Common/Classes/sqSqueakEventsAPI.m'
		'Common/Classes/sqSqueakMainApplication+imageReadWrite.m'
		'Common/Classes/sqSqueakMainApplication+sound.m'
		'Common/Classes/sqSqueakSoundAPI.m'
		'Common/Classes/sqSqueakMainApplication+vmAndImagePath.m'
		'Common/Classes/sqSqueakVmAndImagePathAPI.m'
		'Common/Classes/sqSqueakMainApplication+screen.m'
		'Common/Classes/sqSqueakScreenAPI.m'
		'Common/Classes/sqSqueakScreenAndWindow.m'
		'Common/Classes/sqSqueakCursorAPI.m'
		'Common/Classes/sqSqueakMainApplication+cursor.m'
		'iPhone/Classes/SqueakNoOGLIPhoneAppDelegate.m'
		'iPhone/Classes/sqSqueakIPhoneApplication.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+attributes.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+clipboard.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+imageReadWrite.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+events.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+Network.m'
		'iPhone/Classes/sqSqueakiPhoneApplication+sound.m'
		'iPhone/Classes/sqSqueakIPhoneFileDirectoryInterface.m'
		'iPhone/Classes/sqSqueakIPhoneInfoPlistInterface.m'
		'iPhone/Classes/sqiPhoneScreenAndWindow.m'
		'iPhone/Classes/SqueakUIView.m'
		'iPhone/Classes/SqueakUIViewCALayer.m'
		'iPhone/Classes/SqueakUIViewOpenGL.m'
		'iPhone/Classes/SqueakUIController.m'
		'iPhone/Classes/sqSqueakIPhoneClipboardAPI.m'
		'iPhone/macintoshextra.c'
		'iPhone/osExports.c'
		'iPhone/sqDummyaio.c'
		'iPhone/sqMacV2Memory.c'
		)! !

!StackCocoaIOSARMConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/29/2011 10:26'!
precompiledImports 
	^#(
	'Foundation/Foundation.h' 
	'UIKit/UIKit.h')! !

!StackCocoaIOSARMConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/28/2011 20:38'!
setExtraTargetProperties: maker
	"super setExtraTargetProperties: maker."

	| precompiledHeaders plist |
	
	precompiledHeaders := (self executableName, '_Prefix.pch').
	(maker buildDir forceNewFileNamed: precompiledHeaders) 
		nextPutAll: self precompiledHeaders;
		close.
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/', precompiledHeaders.
	
	maker set: 'CMAKE_CROSSCOMPILING' to: 'TRUE'.
	maker set: 'CMAKE_SYSTEM_NAMEG' toString: 'Darwin'.
	maker set: 'CMAKE_SYSTEM_PROCESSOR' toString: 'arm'.

	maker set: 'SDKVER' toString: '5.0'.
	maker set: 'DEVROOT' toString: '/Developer/Platforms/iPhoneOS.platform/Developer'.
	maker set: 'SDKROOT' toString: '${DEVROOT}/SDKs/iPhoneOS${SDKVER}.sdk'.

	maker include: 'CMakeForceCompiler'.
	maker cmd: 'CMAKE_FORCE_C_COMPILER' params: '${DEVROOT}/usr/bin/clang CLang'.	
	maker cmd: 'CMAKE_FORCE_CXX_COMPILER' params: '${DEVROOT}/usr/bin/clang++ CLang'.

	maker set: 'CMAKE_FIND_ROOT_PATH' to: '"${SDKROOT}" "${DEVROOT}"'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_PROGRAM' to: 'NEVER'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_LIBRARY' to: 'ONLY'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_INCLUDE' to: 'ONLY'.
	
	maker addFrameworks: self frameworks.

	" generated and add Info.plist file "
	plist := self plistFile.

	(maker buildDir forceNewFileNamed: 'Info.plist') 
		nextPutAll: plist; 
		close.

	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.  

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resourcesLocaleEnglish} PROPERTIES MACOSX_PACKAGE_LOCATION Resources/English.lproj'.

	maker 
		cmd: 'set_source_files_properties' 
		params: '${ENGLISH_RESOURCES} PROPERTIES MACOSX_PACKAGE_LOCATION Resources/English.lproj'.
			
	maker 
		cmd: 'set_target_properties' 
		params: self executableName, ' PROPERTIES COMPILE_FLAGS "-include \"', (self buildDir / self prefixHeaderFileName) fullName, '\""'. 
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
	maker set: 'RUNTIME_OUTPUT_DIRECTORY' toString: self outputDir.
! !

!StackCocoaIOSCLANGConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/18/2011 18:30'!
coreSources 
" can't use GCC stuff "
	^ #(
		'interp.c'
		)! !

!StackCocoaIOSCLANGConfig methodsFor: 'as yet unclassified' stamp: 'LucFabresse 12/22/2011 12:05'!
printExtraHeader: maker

	maker set: 'CMAKE_C_COMPILER' to: 'clang'.
	! !

!StackCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 2/5/2011 10:02'!
compilerFlagsRelease 
	^super compilerFlagsRelease, #('-DSTACKVM')! !

!StackCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 2/5/2011 09:40'!
coreSources 
	^ #(
		'gcc3x-interp.c'
		)! !

!StackCocoaIOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/18/2011 15:36'!
executableName
	^ 'StackVM'! !

!StackCocoaIOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:47'!
interpreterClass
	^ StackInterpreter! !

!StackCocoaIOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/23/2011 15:17'!
pluginsDir 
	^'${srcDir}/plugins'! !

!StackCocoaIOSConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

!StackCocoaIOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:52'!
srcDir 
	"Answer the value of srcDir"

	^ srcDir ifNil: [ srcDir := (self topDir / self srcDirName) fullName ]! !

!StackCocoaIOSConfig methodsFor: 'plugins' stamp: 'IgorStasenko 8/8/2011 15:32'!
versionExternalPlugins 
	^Array 
		with: #ThreadedIA32FFIPlugin
		with: #IA32ABIPlugin! !

MacOSConfig subclass: #CogMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!CogMacOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is a concrete configuration for building a CogVM 32 bit on Mac OS.

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).


Fore more information, check the class comments of all the superclasses.
!

CogMacOSConfig subclass: #CogMTMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!CogMTMacOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Mac using the Carbon library. This VM is normally known as CogMTVM.

Fore more information, check the class comments of all the superclasses.
!

!CogMTMacOSConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/19/2011 21:37'!
commonCompilerFlags

	"Common compiler flags"
	
	^ ' -fmessage-length=0 -Wno-trigraphs -fpascal-strings -fasm-blocks -DCOGMTVM=1 -DUSE_GLOBAL_STRUCT=0 -DTARGET_API_MAC_CARBON -DHAVE_SYS_TIME_H -mmacosx-version-min=10.5'	
	! !

!CogMTMacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/19/2011 21:32'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!CogMTMacOSConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/19/2011 21:32'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!CogMTMacOSConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/19/2011 21:32'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		"UnixOSProcessPlugin ?? "
	)! !

!CogMTMacOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:24'!
executableName
	^ 'CogMTVM'! !

!CogMTMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/19/2011 21:30'!
interpreterClass
	^ CoInterpreterMT! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:14'!
CFBundleExecutable
	^ self executableName ! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:11'!
CFBundleGetInfoString

	^ self CFBundleShortVersionString
! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/25/2010 00:37'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:06'!
CFBundleIdentifier

	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	
	^ 'org.squeak.Cog'! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/25/2010 01:36'!
CFBundleName

	"An application name"
	^ self executableName, ' (Carbon) 32bits'! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 19:46'!
CFBundleShortVersionString

	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:09'!
CFBundleVersion

	"An application version"
	^ '4.0.0'! !

!CogMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:39'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'EstebanLorenzano 4/11/2011 16:39'!
commonCompilerFlags

	"Common compiler flags"
	
	^ ' -fmessage-length=0 -Wno-trigraphs -fpascal-strings -fasm-blocks -DCOGMTVM=0 -DUSE_GLOBAL_STRUCT=0 -DTARGET_API_MAC_CARBON -DBUILD_FOR_OSX -DHAVE_SYS_TIME_H -mmacosx-version-min=10.5'	
	
"	^ '-arch i386 -fmessage-length=0 -Wno-trigraphs -fpascal-strings -fasm-blocks -DCOGMTVM=0 -DUSE_GLOBAL_STRUCT=0 -DTARGET_API_MAC_CARBON -DHAVE_SYS_TIME_H -mmacosx-version-min=10.5'"! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/1/2011 14:38'!
compilerFlags
	"depends on config ..."
	^ self compilerFlagsRelease! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/29/2011 11:10'!
compilerFlagsDebug

	^ self commonCompilerFlags , ' -g3 -O0 -Wmissing-prototypes -Wmissing-braces -Wparentheses -Wunused-function -Wunused-label -Wunused-parameter -Wunused-variable -Wunused-value -Wsign-compare -DDEBUGVM=1 -DEXTERNALPRIMSDEBUG=1 -gdwarf-2 '! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/26/2011 20:47'!
compilerFlagsRelease
" -mdynamic-no-pic "
	^ self commonCompilerFlags , ' -gdwarf-2 -O3 -funroll-loops -ftree-vectorize -msse3 -DDEBUGVM=0 -DNDEBUG -Wunused-value -Wuninitialized -falign-functions=16 -fno-gcse -mtune=prescott -march=pentium-m -mfpmath=sse -finline-functions -Wall -DUSE_INLINE_MEMORY_ACCESSORS'! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 12:10'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker addPlatformSources: #( 'sqMacDragDrop')
! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/29/2010 15:19'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.
	
! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 12:12'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker includeDirectories: '${platformsDir}/unix/vm'.
	maker addPlatformSources: #( 'sqMacUnixFileInterface.c' 'sqMacDirectory.c')! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 17:01'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"

	super configureHostWindowPlugin: maker.  
	maker addPlatformSources: #( 'sqMacHostWindow.c' )
! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'MarianoMartinezPeck 4/10/2011 15:10'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/vm/'.
	maker addPlatformSources:
		#( 
			"This is commented because such file is not commited in the cog blessed commit hash f3fe94c828f66cd0e7c37cfa3434e384ff65915e. For more details see http://forum.world.st/Problem-generating-Mac-VM-td3438466.html "
			"'sqMacAudioDeviceList.c'"
			'sqMacUnixInterfaceSound.c' 
			'sqUnixSoundMacOSXJMM.c'
		)


! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 12:17'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	maker addPlatformSources:
		#( 'sqMacUUID.c')


! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/22/2010 15:12'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CogMacOSConfig methodsFor: 'plugins' stamp: 'IgorStasenko 8/8/2011 15:32'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		QuicktimePlugin
"		TestOSAPlugin  - not works"
		"UnixOSProcessPlugin ?? "
		)! !

!CogMacOSConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 12/22/2010 15:47'!
defaultInternalPlugins

	^ #(
		ADPCMCodecPlugin
		AsynchFilePlugin
		B3DAcceleratorPlugin
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin
		DeflatePlugin  "ZipPlugin"
		DropPlugin
		DSAPlugin "DSAPrims"
		FFTPlugin
		FilePlugin
		HostWindowPlugin
		IA32ABIPlugin "IA32ABI"
		InternetConfigPlugin
		JoystickTabletPlugin
		JPEGReaderPlugin
		JPEGReadWriter2Plugin
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		LocalePlugin
		MacMenubarPlugin
		Matrix2x3Plugin
		MIDIPlugin
		MiscPrimitivePlugin
		QVMProfileMacSupportPlugin
		RePlugin
		SecurityPlugin
		SerialPlugin
		SocketPlugin
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin
		SoundPlugin
		StarSqueakPlugin
		SurfacePlugin
		UUIDPlugin
		)! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/23/2010 22:45'!
executableType
	^ 'MACOSX_BUNDLE'! !

!CogMacOSConfig methodsFor: 'settings' stamp: 'Igor.Stasenko 12/23/2010 20:17'!
extraPluginSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/25/2010 01:03'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'${platformsDir}/unix/plugins/SocketPlugin/sqUnixSocket.c 
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/plugins/AsynchFilePlugin/sqUnixAsynchFile.c
	${platformsDir}/unix/vm/sqUnixHeartbeat.c
	${platformsDir}/unix/vm/sqUnixVMProfile.c
	${platformsDir}/unix/vm/sqUnixThreads.c
	${resources}'! !

!CogMacOSConfig methodsFor: 'settings' stamp: 'IgorStasenko 5/3/2011 15:52'!
extraVMSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"'
! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 19:39'!
frameworks

	^ #(
	Carbon
	AppKit
	IOKit
	CoreFoundation
	AudioToolbox
	CoreAudio
	OpenGL
	AGL
	QuickTime
	Foundation
	SystemConfiguration
	)! !

!CogMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:30'!
interpreterClass
	^ CoInterpreter! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 16:47'!
platformName
	^ 'Mac OS'! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/23/2010 20:00'!
platformSources
	"files added from platform/Mac OS/vm dir "
	^ #(
	'NSCursorWrappers.m'
	'nsPoolManagement.m'
	'osExports.c'
	'sqMacEncoding.c'
	'sqMacImageIO.c'
	'sqMacMain.c'
	'sqMacMemory.c'
	'sqMacNSPluginUILogic2.c'
	'sqMacTime.c'
	'sqMacUIAppleEvents.c'
	'sqMacUIClipBoard.c'
	'sqMacUIEventsUniversal.c'  " instead of: sqMacUIEvents.c "
	'sqMacUIMenuBarUniversal.c'
	'sqMacUnixCommandLineInterface.c'
	'sqMacUnixExternalPrims.c'
	'sqMacWindowUniversal.c'
	'version.c'	
	)! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:19'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier ) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:12'!
plistTemplate
	^ 
	'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>LSMinimumSystemVersion</key>
	<string>10.5.0</string>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>bundle</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakPlugin.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Plugin</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BNDL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CGDisableCoalescedUpdates</key>
	<true/>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>NSServices</key>
	<array>
		<dict>
			<key>NSMenuItem</key>
			<dict>
				<key>default</key>
				<string>Squeak DoIt</string>
			</dict>
			<key>NSMessage</key>
			<string>doitandreturn</string>
			<key>NSPortName</key>
			<string>Squeak</string>
			<key>NSReturnTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
			<key>NSSendTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
		</dict>
	</array>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakEncodingType</key>
	<string>UTF-8</string>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakFloatingWindowGetsFocus</key>
	<true/>
	<key>SqueakHasQuitWithoutSaving</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCheckForPossibleNeedEveryNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCleanupDelayMilliseconds</key>
	<integer>25</integer>
	<key>SqueakUIFlushUseHighPercisionClock</key>
	<true/>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Croquet/Internet/Untrusted/</string>
	<key>SqueakWindowAttribute</key>
	<data>ggAAHw==</data>
	<key>SqueakWindowHasTitle</key>
	<true/>
	<key>SqueakWindowType</key>
	<integer>6</integer>
</dict>
</plist>
'! !

!CogMacOSConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:50'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!CogMacOSConfig methodsFor: 'settings' stamp: 'IgorStasenko 7/5/2011 01:28'!
setExtraTargetProperties: maker

	super setExtraTargetProperties: maker.

	maker addFrameworks: self frameworks.	

	" generated and add Info.plist file "
	self write: self plistFile toFile: 'Info.plist'.
	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.

	maker cmd: 'set_source_files_properties' params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' to: '${outputDir}'.! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/23/2010 20:45'!
standardIncludes
	^ #(
	'SYSTEM /Developer/Headers/FlatCarbon'
	'${targetPlatform}/vm/Developer'  "for some unknown reason sqGnu.h is put there"
	
	'${crossDir}/plugins/SerialPlugin'   "for platforms/Mac OS/vm/osExports.c to work"
	'${targetPlatform}/plugins/FilePlugin'   "for sqMacFileLogic.h to work"
	'${targetPlatform}/plugins/HostWindowPlugin'  "for sqMacNSPluginUILogic2.c to work"
	'${crossDir}/plugins/HostWindowPlugin' "for same... "
	'${crossDir}/plugins/DropPlugin' "include DropPlugin.h"
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'  "suppressing following:
		platforms/Mac OS/vm/sqMacMain.c:94:19: error: sqaio.h: No such file or directory
		platforms/Mac OS/vm/sqMacMain.c:96:28: error: sqUnixCharConv.h: No such file or directory"
	)
	! !

CogMacOSConfig subclass: #CogMacOSDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!CogMacOSDebugConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is a concrete class which generates a DEBUG CogVM for Mac using Carbon library. This VM is normally known as a debug CogVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.

Fore more information, check the class comments of all the superclasses.
!

!CogMacOSDebugConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/1/2011 14:37'!
compilerFlags

    ^  self compilerFlagsDebug! !

CogMacOSConfig subclass: #StackMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!StackMacOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is a concrete class which generates a StackVM for Mac using the Carbon library.

This configuration generates sources/build files for building Stack-based interpreter on Mac OS X.
It is using a Carbon framework , which will be replaced by Cocoa soon. (see CocoaIOSConfig and its subclasses).

Fore more information, check the class comments of all the superclasses.
!

!StackMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/30/2010 09:46'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/30/2010 10:16'!
executableName
	^ 'StackVM'! !

!StackMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:06'!
interpreterClass
	^ StackInterpreter! !

!StackMacOSConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

StackMacOSConfig subclass: #StackMacOSDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!StackMacOSDebugConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is a concrete class which generates a DEBUG StackVM for Mac using Carbon library. This VM is normally known as a debug StackVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.

Fore more information, check the class comments of all the superclasses.
!

!StackMacOSDebugConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/1/2011 14:50'!
compilerFlags

    ^  self compilerFlagsDebug! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 4/11/2011 14:14'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker.  
	
	maker 
		includeDirectories: '/usr/X11/include';  "for GL.h"
		addPlatformSources: #( 'sqMacOpenGL.c' 'sqMacOpenGLInfo.c')
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'MarianoMartinezPeck 4/23/2011 13:30'!
configureClipboardExtendedPlugin: maker
	! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:16'!
configureCroquetPlugin: maker 
	"extra rules for CroquetPlugin"

	super configureCroquetPlugin: maker.  
	maker addPlatformSources: #('sqMacCroquet.c').
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:23'!
configureFFIPlugin: maker
	super configureFFIPlugin: maker.
	maker addPlatformSources: #( "'sqMacIntel-Win32.c'"
		'x86-sysv-MacIntel.c'
		'x86-sysv-asm-MacIntel.S'
	)! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/5/2011 02:02'!
configureFT2Plugin: maker
	"extra rules for Freetype plugin.
	a custom rule to build freetype library"


	maker cmd: 'add_custom_command' params: 'OUTPUT "${buildDir}/FT2Plugin/libfreetype.a" 
		COMMAND "${topDir}/macbuild/FT2Plugin/makeFreetype.sh" "${buildDir}/FT2Plugin/libfreetype.a"
		COMMENT "Building freetype library"
	'.

	maker addExternalLibrary: '${buildDir}/FT2Plugin/libfreetype.a'.

	maker addSource: '${buildDir}/FT2Plugin/libfreetype.a'.
	
	
	"the freetype sources are located in {build}/FT2Plugin/freetype2/include "
	maker includeDirectories: '${buildDir}/FT2Plugin/freetype2/include'
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:19'!
configureInternetConfigPlugin: maker
	"extra rules for InternetConfigPlugin"
	
	super configureInternetConfigPlugin: maker.  
	maker addPlatformSources: #( 'sqMacInternetConfiguration.c')
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:19'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 
			'HID_Error_Handler.c'
			'HID_Name_Lookup.c'
			'HID_Queue_Utilities.c'
			'HID_Utilities.c'
			'sqMacJoystickAndTablet.c'
			)
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"

	super configureLocalePlugin: maker.  
	maker addPlatformSources: #( 'sqMacLocaleCarbon.c' )
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureMIDIPlugin: maker.  
	maker addPlatformSources: #( 'sqMacMIDI.c')! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/15/2011 15:38'!
configureMpeg3Plugin: maker

	super configureMpeg3Plugin: maker.
	
	maker addPlatformSources: #(	
		'sqMacFileBits.c')
	! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/3/2011 07:28'!
configureObjectiveCPlugin: maker
	maker doNotGenerate: true! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/5/2011 01:29'!
configurePlugin: aPlugin with: generator

	generator isExternal ifTrue: [
		" set output directory for dynamic library to Resources subdir in .app bundle location "
		generator 
			set: 'CMAKE_LIBRARY_OUTPUT_DIRECTORY' 
			toString: ('${outputDir}/', self executableName, '.app/Contents/Resources')
		].
	^ super configurePlugin: aPlugin with: generator
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/26/2011 23:12'!
configureQuicktimePlugin: maker
	
	maker includeDirectories: '${pluginPlatform}'.
	maker includeDirectories: '${crossDir}/plugins/SurfacePlugin'.
	
	" yes, this is not a typo , a file is named 'inteface' instead of 'interface' "

	maker addPlatformSources: #( 'sqMacQuicktimeInteface.c' ).
	
	maker addFrameworks: #( 'Carbon' 'QuickTime' ).! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:21'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"

	super configureSecurityPlugin: maker.  
	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker addPlatformSources: #( 'sqMacSecurity.c' )! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:21'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"

	super configureSerialPlugin: maker.  
	maker addPlatformSources: #( 'sqMacSerialPort.c' )

! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/3/2011 14:22'!
configureSocketPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/plugins/SocketPlugin'.
	maker 
		addSources: #('sqUnixSocket.c') 
		prefixed: '${platformsDir}/unix/plugins/SocketPlugin/'


! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 8/9/2011 14:15'!
configureSoundGenerationPlugin: maker 
	"extra rules for SoundPlugin"

	maker doNotGenerate: true. 
	" The sources in platforms/Cross/plugins/SoundGenerationPlugin/sqOldSoundPrims.c 
	are out of date and need to be fixed before it can be built 
	
	
	maker 
		addCrossSources: #('sqOldSoundPrims.c') 

	"
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/26/2011 23:11'!
configureTestOSAPlugin: maker
		
	maker addFrameworks: #( 'Carbon'  'ApplicationServices' ).! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/6/2011 05:21'!
configureUnixOSProcessPlugin: maker 
	"extra rules for UnixOSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
! !

!MacOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 22:17'!
defaultDirectoriesFromGitDir: gitRepository
	"Set the default values for all necessary directories taking into account the Git repostiory. An example to use this method is:
	MTCocoaIOSCogJitDebugConfig new
	defaultDirectoriesFromGitDir: '/Users/mariano/Pharo/vm/git/cogVM/blessed';
	generateSources; 
	generate.
	"
	| gitRepositoryString |
	gitRepositoryString :=  gitRepository, '/'.
	self srcDir: gitRepositoryString, self srcDirName.
    	self platformsDir: gitRepositoryString, self platformsDirName.
    	self buildDir: gitRepositoryString, self buildDirName.
	self resourcesDir: gitRepositoryString, self resourcesDirName.
	self outputDir: gitRepositoryString, self outputDirName.
	
	
	! !

!MacOSConfig methodsFor: 'utils' stamp: 'EstebanLorenzano 1/3/2011 08:16'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String lf! !

!MacOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 22:00'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self buildDir containingDirectory fullName , '/', self outputDirName) ]
	! !

!MacOSConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	! !

!MacOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:04'!
resourcesDir 
	"Answer the value of resourcesDir"

	^ resourcesDir ifNil: [ resourcesDir := (self topDir / 'macbuild/resources') fullName ]
	! !

!MacOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:03'!
resourcesDir: anObject
	"Set the value of platformsDir"

	resourcesDir := anObject! !

!MacOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:57'!
resourcesDirName
	^ 'macbuild/resources'! !
